/** 
 * @file  AquaMessageSystem.cpp
 * @brief bZ[WVXeNX\[Xt@C
 * @note bZ[Wf[^Ɋւ鏈s܂<br>
 * @date 2008/03/14
 */
#ifdef WIN32
#define _CRT_SECURE_NO_DEPRECATE		// n֐̃ZLeBɊւx̗}p(.net2005ȍ~̑Ώ)
#endif // WIN32

static char Copyright[] = "AquaMessageSystem Copyright (c) 2008-2009 AquaSystem Project.";
static char Version[] = "AquaMessageSystem Version 2.00.0";

#include "AquaNetworkSystem.h"
#include "AquaMessageSystem.h"

#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#else // WIN32
#include <sys/socket.h>
#include <netdb.h>
#endif // WIN32

#include <stdio.h>
#include <string.h>

#ifndef WIN32
size_t _tcscnlen(const char * _String, size_t _Maximum) 
{
    return strlen(_String);
}
char* _tcsncpy_s(char * _Destination, size_t _Destination_size_chars, const char * _Source, size_t _Count) 
{
    return strncpy(_Destination, _Source, _Destination_size_chars);
}
int _tcscmp(const char* _s1, const char* _s2)
{
	return strcmp(_s1, _s2);
}
#endif // WIN32


#ifndef ARRAY_NUM
#define ARRAY_NUM(x) (sizeof(x) / sizeof(x)[1])
#endif // ARRAY_NUM

static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host_str, size_t host_strlen)
{
	if(NULL == sa) { return; }

	char host[NI_MAXHOST] = "";
	char serv[NI_MAXSERV] = "";
	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv6)", host, serv);
		} else {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv4)", host, serv);
		} else {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host_str, host_strlen, "unknown");
	} else {
		_snprintf(host_str, host_strlen, "unknown");
	}
}
static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host, size_t hostlen, char* serv, size_t servlen)
{
	if(NULL == sa) { return; }
	if(NULL == host) { return; }
	if(NULL == serv) { return; }

	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	} else {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	}
}

/**
 * @namespace AquaMessageSystem
 */
namespace AquaMessageSystem {

//==============================================
// class CAquaMessageUser
//==============================================
/** RXgN^
 */
CAquaMessageUser::CAquaMessageUser()
{
	memset(m_uid, '\0', sizeof(m_uid));
	memset(m_passwd, '\0', sizeof(m_passwd));
}
/** fXgN^
 */
CAquaMessageUser::~CAquaMessageUser()
{
}
/** Rs[RXgN^
 * @param rAquaMessageUser Rs[IuWFNgւ̎Q
 */
CAquaMessageUser::CAquaMessageUser(const CAquaMessageUser& rAquaMessageUser)
{
	*this = rAquaMessageUser;
}
/** Zq̃I[o[Ch
 */
CAquaMessageUser& CAquaMessageUser::operator=(const CAquaMessageUser& rAquaMessageUser)
{
	this->set_uid(rAquaMessageUser.get_uid(), rAquaMessageUser.get_uid_size());
	this->set_passwd(rAquaMessageUser.get_passwd(), rAquaMessageUser.get_passwd_size());
	return *this;
}
/** uid擾
 * @retval 擾uidւ̃|C^
 */
LPCTSTR CAquaMessageUser::get_uid(void) const
{
	return m_uid;
}
/** uid̒擾
 * @retval 擾uid̒
 */
size_t CAquaMessageUser::get_uid_size(void) const
{
	return _tcscnlen(m_uid, sizeof(m_uid));
}
/** uidݒ肷
 * @param uid ݒ肷uidւ̃|C^
 * @param size ݒ肷uid̒
 */
void CAquaMessageUser::set_uid(LPCTSTR uid, size_t size)
{
	if(NULL == uid) { return; }
	::_tcsncpy_s(m_uid, sizeof(m_uid), uid, size);
}
/** passwd擾
 * @retval 擾passwdւ̃|C^
 */
LPCTSTR CAquaMessageUser::get_passwd(void) const
{
	return m_passwd;
}
/** passwd̒擾
 * @retval 擾passwd̒
 */
size_t CAquaMessageUser::get_passwd_size(void) const
{
	return _tcscnlen(m_passwd, sizeof(m_passwd));
}
/** passwdݒ肷
 * @param passwd ݒ肷passwdւ̃|C^
 * @param size ݒ肷passwd̒
 */
void CAquaMessageUser::set_passwd(LPCTSTR passwd, size_t size)
{
	if(NULL == passwd) { return; }
	::_tcsncpy_s(m_passwd, sizeof(m_passwd), passwd, size);
}

//==============================================
// class CAquaMessageSession
//==============================================
/** RXgN^
 */
CAquaMessageSession::CAquaMessageSession()
{
	m_ns = NULL;
	m_ns_udp = NULL;
}
/** fXgN^
 */
CAquaMessageSession::~CAquaMessageSession()
{
//	close_session();
	detach_session();
}
/** Rs[RXgN^
 * @param rAquaMessageSession Rs[IuWFNgւ̎Q
 */
CAquaMessageSession::CAquaMessageSession(const CAquaMessageSession& rAquaMessageSession)
{
	this->m_ns = rAquaMessageSession.m_ns;
	this->m_ns_udp = rAquaMessageSession.m_ns_udp;
}
/** ZqI[oCh
 * @param rAquaMessageSession IuWFNgւ̎Q
 * @retval IuWFNgւ̎Q
 */
CAquaMessageSession CAquaMessageSession::operator=(const CAquaMessageSession& rAquaMessageSession)
{
	this->m_ns = rAquaMessageSession.m_ns;
	this->m_ns_udp = rAquaMessageSession.m_ns_udp;
	return *this;
}
/** ZqI[oCh
 * @param rAquaMessageSession rΏۃIuWFNgւ̎Q
 * @retval false:ł͂Ȃ false:ł
 */
bool CAquaMessageSession::operator==(const CAquaMessageSession& rAquaMessageSession) const
{
	if(this->m_ns != rAquaMessageSession.m_ns) {
		return false;
	}
	if(this->m_ns_udp != rAquaMessageSession.m_ns_udp) {
		return false;
	}
	return true;
}
/** sZqI[oCh
 * @param rAquaMessageSession rΏۃIuWFNgւ̎Q
 * @retval false:sł͂Ȃ false:sł
 */
bool CAquaMessageSession::operator!=(const CAquaMessageSession& rAquaMessageSession) const
{
	if(this->m_ns == rAquaMessageSession.m_ns) {
		return false;
	}
	if(this->m_ns_udp == rAquaMessageSession.m_ns_udp) {
		return false;
	}
	return true;
}
/** ZbV֘At
 * @param session ֘AZbV
 */
void CAquaMessageSession::attach_session(AquaNetworkSystem::CAquaNetworkSession* session)
{
	m_ns = session;
}
/** ZbV֘At
 */
void CAquaMessageSession::detach_session(void)
{
	m_ns = NULL;
}
/** ֘AtꂽZbV͗LǂH
 * @retval true:Lł
 * @retval false:Lł͂Ȃ
 */
bool CAquaMessageSession::is_session_used(void) const
{
	if(NULL == m_ns) { return false; }
	return m_ns->IsUsed();
}
/** ֘AtꂽZbV
 */
void CAquaMessageSession::close_session(void)
{
	if(NULL == m_ns) { return; }
	// clientؒf
	m_ns->close();
	m_ns->SetUsed(false);
}
/** ֘AtꂽZbVgpăbZ[W𑗐M
 * @param pMessageData M郁bZ[Wf[^
 * @param nMessageDataSize M郁bZ[Wf[^̃TCY
 * @retval MbZ[W̃TCY
 */
int CAquaMessageSession::send_message(const void* pMessageData, size_t nMessageDataSize)
{
	if(NULL == m_ns) { return -1; }
	while(AquaNetworkSystem::CRYPTO_STATE_PLAIN == m_ns->GetCryptoStateRecv() || AquaNetworkSystem::CRYPTO_STATE_PLAIN == m_ns->GetCryptoStateSend()) {
		if(!m_ns->IsUsed()) { return 0; }
#ifdef WIN32
		Sleep(1000);
#else
		sleep(1);
#endif
	}

	// message echo back to client
	int send_size = m_ns->send((const unsigned char*)pMessageData, (int)nMessageDataSize, 0);
	return send_size;
}
/** ZbV֘At
 * @param session ֘AZbV
 */
void CAquaMessageSession::attach_udp_session(AquaNetworkSystem::CAquaNetworkUDPSession* session)
{
	m_ns_udp = session;
}
/** ZbV֘At
 */
void CAquaMessageSession::detach_udp_session(void)
{
	m_ns_udp = NULL;
}
/** ֘AtꂽZbV͗LǂH
 * @retval true:Lł
 * @retval false:Lł͂Ȃ
 */
bool CAquaMessageSession::is_udp_session_used(void) const
{
	if(NULL == m_ns_udp) { return false; }
	return m_ns_udp->IsUsed();
}
/** ֘AtꂽZbV
 */
void CAquaMessageSession::close_udp_session(void)
{
	if(NULL == m_ns_udp) { return; }
	// clientؒf
	m_ns_udp->close();
	m_ns_udp->SetUsed(false);
}
/** ֘AtꂽZbVgpăbZ[W𑗐M
 * @param pMessageData M郁bZ[Wf[^
 * @param nMessageDataSize M郁bZ[Wf[^̃TCY
 * @param hostname MzXg
 * @param service MT[rX
 * @retval MbZ[W̃TCY
 */
int CAquaMessageSession::sendto_udp_message(const void* pMessageData, size_t nMessageDataSize, const char* hostname, const char* service)
{
	if(NULL == hostname) { return SOCKET_ERROR; }
	if(0 == service) { return SOCKET_ERROR; }
	if(NULL == m_ns_udp) { return -1; }

	struct addrinfo hints;
	struct addrinfo* res = NULL;
	struct addrinfo* ai;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	if(0 != getaddrinfo(hostname, service, &hints, &res)) {
		return INVALID_SOCKET;
	}
	int send_size = 0;
	for (ai = res; ai; ai = ai->ai_next) {
		// message echo back to client
		send_size = m_ns_udp->sendto((const unsigned char*)pMessageData, (int)nMessageDataSize, 0, ai->ai_addr, ai->ai_addrlen);
		break;
	}
	freeaddrinfo(res);
	return send_size;
}


//==============================================
// class CAquaMessageUserManager
//==============================================
/** RXgN^
 */
CAquaMessageUserManager::CAquaMessageUserManager()
{
}
/** fXgN^
 */
CAquaMessageUserManager::~CAquaMessageUserManager()
{
}
/** [U̒ǉ
 * @param uid ǉuid([UID)ւ̃|C^
 * @param uid_size ǉuid([UID)̒
 * @param passwd ǉpasswd(pX[h)ւ̃|C^
 * @param passwd_size ǉpasswd(pX[h)̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageUserManager::add_user(LPCTSTR uid, size_t uid_size, LPCTSTR passwd, size_t passwd_size)
{
	CAquaMessageUser new_user;
	new_user.set_uid(uid, uid_size);
	new_user.set_passwd(passwd, passwd_size);
	m_AquaMessageUserArray.push_back(new_user);
	return 1; 
}
/** wuid([UID)̃[U폜
 * @param uid 폜uid([UID)ւ̃|C^
 * @param uid_size 폜uid([UID)̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageUserManager::delete_user(LPCTSTR uid, size_t uid_size)
{
	for(std::vector<CAquaMessageUser>::iterator it=m_AquaMessageUserArray.begin(); it!=m_AquaMessageUserArray.end(); it++) {
		if(0 != ::_tcscmp((*it).get_uid(), uid)) { continue; }
		it = m_AquaMessageUserArray.erase(it);
		return 1;
	}
	return 0;
}
/** S[U̒ǉ
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageUserManager::delete_alluser(void)
{
	m_AquaMessageUserArray.clear();
	return 1;
}
/** [UQƂ
 * @param uid QƂ郆[Uuid([UID)ւ̃|C^
 * @param uid_size QƂ郆[Uuid([UID)̒
 * @retval [Uւ̎Q
 */
CAquaMessageUser CAquaMessageUserManager::reference_user(LPCTSTR uid, size_t uid_size) const
{
	CAquaMessageUser user;
	for(std::vector<CAquaMessageUser>::const_iterator it=m_AquaMessageUserArray.begin(); it!=m_AquaMessageUserArray.end(); it++) {
		if(0 != ::_tcscmp((*it).get_uid(), uid)) { continue; }
		user = *it;
		break;
	}
	return user;
}
/** [Ȕ擾
 * @param uid 擾郆[Uuid([UID)ւ̃|C^
 * @param uid_size 擾郆[Uuid([UID)̒
 * @retval [U[ւ̃|C^
 */
CAquaMessageUser* CAquaMessageUserManager::get_user(LPCTSTR uid, size_t uid_size)
{
	CAquaMessageUser* user = NULL;
	for(std::vector<CAquaMessageUser>::iterator it=m_AquaMessageUserArray.begin(); it!=m_AquaMessageUserArray.end(); it++) {
		if(0 != ::_tcscmp((*it).get_uid(), uid)) { continue; }
		user = &(*it);
		break;
	}
	return user;
}
/** [Ȕ擾(const)
 * @param uid 擾郆[Uuid([UID)ւ̃|C^
 * @param uid_size 擾郆[Uuid([UID)̒
 * @retval [U[ւ̃|C^
 */
const CAquaMessageUser*	CAquaMessageUserManager::get_user(LPCTSTR uid, size_t uid_size) const
{
	const CAquaMessageUser* user = NULL;
	for(std::vector<CAquaMessageUser>::const_iterator it=m_AquaMessageUserArray.begin(); it!=m_AquaMessageUserArray.end(); it++) {
		if(0 != ::_tcscmp((*it).get_uid(), uid)) { continue; }
		user = &(*it);
		break;
	}
	return user;
}

//==============================================
// class CAquaMessageSystem
//==============================================
/** RXgN^
 */
CAquaMessageSystem::CAquaMessageSystem()
{
	m_service_type = AQUAMESSYS_SERVICE_TYPE_NONE;
	memset(m_error_msg, '\0', sizeof(m_error_msg));
	try {
		m_nsm = new AquaNetworkSystem::CAquaNetworkSessionManager();
	}
	catch(std::bad_alloc) {
		m_nsm = NULL;
	}
}
/** fXgN^
 */
CAquaMessageSystem::~CAquaMessageSystem()
{
	if(NULL != m_nsm) {
		delete m_nsm;
		m_nsm = NULL;
	}
}
/// ʐMpZbV̍쐬
int CAquaMessageSystem::CreateSessions(int session_max)
{
	if(NULL == m_nsm) { return 0; }
	return m_nsm->CreateSessions(session_max);
}
/// ʐM҂󂯗pZbV̍쐬
int CAquaMessageSystem::CreateListenSessions(int listen_session_max)
{
	if(NULL == m_nsm) { return 0; }
	return m_nsm->CreateListenSessions(listen_session_max);
}
/// UDPʐMpZbV̍쐬
int CAquaMessageSystem::CreateUDPSessions(int udp_session_max)
{
	if(NULL == m_nsm) { return 0; }
	return m_nsm->CreateUDPSessions(udp_session_max);
}
/// ʐMpZbV̍폜
void CAquaMessageSystem::ReleaseSessions(void)
{
	if(NULL == m_nsm) { return; }
	m_nsm->ReleaseSessions();
}
/// ʐM҂󂯗pZbV̍폜
void CAquaMessageSystem::ReleaseListenSessions(void)
{
	if(NULL == m_nsm) { return; }
	m_nsm->ReleaseListenSessions();
}
/// UDPʐMpZbV̍폜
void CAquaMessageSystem::ReleaseUDPSessions(void)
{
	if(NULL == m_nsm) { return; }
	m_nsm->ReleaseUDPSessions();
}
/** SocketEvent̏
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::InitSocketEvent(void)
{
	if(NULL == m_nsm) { return 0; }

	if(0 >= m_nsm->CreateParseRecvSocketBufferThread()) {
		return 0;
	}

	if(0 >= m_nsm->InitLibEvent()) {
		return 0;
	}
	return 1;
}
/** SocketEvent̔M
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::DispatchSocketEvent(void)
{
	if(NULL == m_nsm) { return 0; }
	return m_nsm->DispatchLibEvent();
}
/** ZbV̑҂󂯂Jn
 * @param service ҂󂯃T[rX
 * @param family gpTCP/IPAhXt@~[(PF_INET/PF_INET6/PF_UNSPEC)
 * @param AquaMessageSystemCryptoAlgorithm ʐMÍɎgpASY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::listen(const char* service, int family, eAquaMessageSystemCryptoAlgorithm AquaMessageSystemCryptoAlgorithm)
{
	if(NULL == m_nsm) { return 0; }
	if(AQUAMESSYS_SERVICE_TYPE_NONE != m_service_type) {
		return 0;
	}
	AquaNetworkSystem::eCryptoAlgorithm CryptoAlgorithm = AquaNetworkSystem::CRYPTO_ALGORITHM_NONE;
	switch(AquaMessageSystemCryptoAlgorithm) {
	case AQUAMESSYS_CRYPTO_ALGORITHM_NONE:
		CryptoAlgorithm = AquaNetworkSystem::CRYPTO_ALGORITHM_NONE;
		break;
	case AQUAMESSYS_CRYPTO_ALGORITHM_3DES:
		CryptoAlgorithm = AquaNetworkSystem::CRYPTO_ALGORITHM_3DES;
		break;
	case AQUAMESSYS_CRYPTO_ALGORITHM_BLOWFISH:
		CryptoAlgorithm = AquaNetworkSystem::CRYPTO_ALGORITHM_BLOWFISH;
		break;
	default:
		CryptoAlgorithm = AquaNetworkSystem::CRYPTO_ALGORITHM_NONE;
		break;
	}
	int iRet = m_nsm->Listen(service, family, 5, cbfunc_Recv, this, CryptoAlgorithm);
	if(0 == iRet) {
		return 0;
	}
	m_service_type = AQUAMESSYS_SERVICE_TYPE_NONE;
	return 1;
}
/** ZbV̑҂󂯂I
 * @param service ҂󂯂IT[rX
 */
void CAquaMessageSystem::close_listen(const char* service)
{
	if(NULL == m_nsm) { return; }
	m_nsm->CloseListen(service);
}
/** Fؗp[UXg[h
 * @param lpFileName Fؗp[UXg̃t@C
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::load_auth_user_list(LPCTSTR lpFileName)
{
	if(NULL == lpFileName) { return 0; }

	FILE* pFile = _tfopen(lpFileName, _T("rt"));
	if(NULL == pFile) { return 0; }
	m_mum_auth.delete_alluser();
	while(1) {
		TCHAR uid[UID_LEN_MAX] = _T(""); 
		TCHAR passwd[PASSWD_LEN_MAX] = _T(""); 

		int iRet = _ftscanf(pFile, _T("%s\t%s\n"), uid, passwd);
		if(EOF == iRet) { break; }
		m_mum_auth.add_user(uid, _tcscnlen(uid, sizeof(uid)), passwd, _tcscnlen(passwd, sizeof(passwd)));
	}
	fclose(pFile);

	return 1;
}
/** ZbVւ̐ڑ
 * @param hostname ڑzXg
 * @param service ڑT[rX
 * @retval ZbVNX̃IuWFNgւ̃|C^BsNULLԂ܂B
 */
CAquaMessageSession* CAquaMessageSystem::connect(const char* hostname, const char* service)
{
	if(NULL == m_nsm) { return NULL; }
	CAquaMessageSession* pAquaMessageSession = NULL;
	try {
		pAquaMessageSession = new CAquaMessageSession();
	} catch(std::bad_alloc) {
		return NULL;
	}
	if(AQUAMESSYS_SERVICE_TYPE_NONE != m_service_type) {
		return NULL;
	}
	AquaNetworkSystem::CAquaNetworkSession* session = m_nsm->ConnectSecure(hostname, service, cbfunc_Recv, this);
	if(NULL == session) {
		return NULL;
	}
	pAquaMessageSession->attach_session(session);
	return pAquaMessageSession;
}
/** [UF؂
 * @param uid F؂郆[Uuid([UID)ւ̃|C^
 * @param uid_size F؂郆[Uuid([UID)̒
 * @param passwd F؂郆[Upasswd(pX[h)ւ̃|C^
 * @param passwd_size F؂郆[Upasswdpasswd(pX[h)̒
 * @retval [U[ւ̃|C^
 */
int CAquaMessageSystem::auth(CAquaMessageSession* session, LPCTSTR uid, size_t uid_size, LPCTSTR passwd, size_t passwd_size)
{
	tagMessageDataUserAuthRequest mes;
	memset(&mes, 0, sizeof(mes));
	mes.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_USER_AUTH_REQUSET;
	mes.m_header.m_size = (unsigned short)(sizeof(tagMessageDataUserAuthRequest));
	::_tcsncpy_s(mes.m_uid, sizeof(mes.m_uid), uid, uid_size);
	::_tcsncpy_s(mes.m_passwd, sizeof(mes.m_passwd), passwd, passwd_size);
	session->send_message(&mes, sizeof(tagMessageDataUserAuthRequest));
	return 1;
}
/** [U̒ǉ
 * @param uid ǉuid([UID)ւ̃|C^
 * @param uid_size ǉuid([UID)̒
 * @param passwd ǉpasswd(pX[h)ւ̃|C^
 * @param passwd_size ǉpasswd(pX[h)̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::add_user(LPCTSTR uid, size_t uid_size, LPCTSTR passwd, size_t passwd_size)
{
	return m_mum.add_user(uid, uid_size, passwd, passwd_size);
}
/** wuid([UID)̃[U폜
 * @param uid 폜uid([UID)ւ̃|C^
 * @param uid_size 폜uid([UID)̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::delete_user(LPCTSTR uid, size_t uid_size)
{
	return m_mum.delete_user(uid, uid_size);
}
/** S[U̒ǉ
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::delete_alluser(void)
{
	return m_mum.delete_alluser();
}
/** [UQƂ
 * @param uid QƂ郆[Uuid([UID)ւ̃|C^
 * @param uid_size QƂ郆[Uuid([UID)̒
 * @retval [Uւ̎Q
 */
CAquaMessageUser CAquaMessageSystem::reference_user(LPCTSTR uid, size_t uid_size) const
{
	return m_mum.reference_user(uid, uid_size);
}
/** [Ȕ擾
 * @param uid 擾郆[Uuid([UID)ւ̃|C^
 * @param uid_size 擾郆[Uuid([UID)̒
 * @retval [U[ւ̃|C^
 */
CAquaMessageUser* CAquaMessageSystem::get_user(LPCTSTR uid, size_t uid_size)
{
	return m_mum.get_user(uid, uid_size);
}
/** [Ȕ擾(const)
 * @param uid 擾郆[Uuid([UID)ւ̃|C^
 * @param uid_size 擾郆[Uuid([UID)̒
 * @retval [U[ւ̃|C^
 */
const CAquaMessageUser* CAquaMessageSystem::get_user(LPCTSTR uid, size_t uid_size) const
{
	return m_mum.get_user(uid, uid_size);
}
/** ZbVւ̐ڑsA[UFؗv𑗐M܂
 * @param hostname ڑzXg
 * @param service ڑT[rX
 * @param uid F؂郆[Uuid([UID)ւ̃|C^
 * @param uid_size F؂郆[Uuid([UID)̒
 * @param passwd F؂郆[Upasswd(pX[h)ւ̃|C^
 * @param passwd_size F؂郆[Upasswdpasswd(pX[h)̒
 * @retval ZbVNX̃IuWFNgւ̃|C^BsNULLԂ܂B
 */
CAquaMessageSession* CAquaMessageSystem::connect(const char* hostname, const char* service, LPCTSTR uid, size_t uid_size, LPCTSTR passwd, size_t passwd_size)
{
	CAquaMessageSession* pAquaMessageSession = NULL;
	if(AQUAMESSYS_SERVICE_TYPE_NONE != m_service_type) {
		return NULL;
	}

	pAquaMessageSession = this->connect(hostname, service);
	if(NULL == pAquaMessageSession) {
		return NULL;
	}
	if(!pAquaMessageSession->is_session_used()) {
		delete pAquaMessageSession;
		return NULL;
	}
	if(0 == this->auth(pAquaMessageSession, uid, uid_size, passwd, passwd_size)) {
		pAquaMessageSession->close_session();
		pAquaMessageSession->detach_session();
		delete pAquaMessageSession;
		return NULL;
	}
	m_service_type = AQUAMESSYS_SERVICE_TYPE_NONE;
	return pAquaMessageSession;
}
/** ZbVւ̐ؒfs
 * @param session ؒfZbV֘AtꂽbZ[WʐMZbVIuWFNg(CAquaMessageSession)
 */
void CAquaMessageSystem::close(class CAquaMessageSession* session)
{
	m_nsm->Close(session->m_ns);
}
/** UDPZbV̐ؒfs
 * @param session ؒfUDPZbV֘AtꂽbZ[WʐMZbVIuWFNg(CAquaMessageSession)
 */
void CAquaMessageSystem::close_udp(class CAquaMessageSession* session)
{
	m_nsm->CloseUDPSession(session->m_ns_udp);
}
/** UDPZbVJ
 * @param family gpTCP/IPAhXt@~[(PF_INET/PF_INET6)
 * @retval ZbVNX̃IuWFNgւ̃|C^BsNULLԂ܂B
 */
CAquaMessageSession* CAquaMessageSystem::open_udp(int family)
{
	if(NULL == m_nsm) { return NULL; }
	CAquaMessageSession* pAquaMessageSession = NULL;
	try {
		pAquaMessageSession = new CAquaMessageSession();
	} catch(std::bad_alloc) {
		return NULL;
	}
	AquaNetworkSystem::CAquaNetworkUDPSession* session = m_nsm->OpenUDPSession(family, cbfunc_udp_Recv, this);
	if(NULL == session) {
		return NULL;
	}
	pAquaMessageSession->attach_udp_session(session);
	return pAquaMessageSession;
}
/** UDPBindZbVJ
 * @param service ҂󂯃T[rX
 * @param family gpTCP/IPAhXt@~[(PF_INET/PF_INET6/PF_UNSPEC)
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::open_udp_bind(const char* service, int family)
{
	if(NULL == m_nsm) { return 0; }
	if(NULL == service) { return 0; }
	return m_nsm->OpenUDPBindSession(service, family, cbfunc_udp_Recv, this);
}
/** UDPBindZbV
 * @param service ҂󂯂IT[rX
 */
void CAquaMessageSystem::close_udp_bind(const char* service)
{
	if(NULL == m_nsm) { return; }
	if(NULL == service) { return; }
	m_nsm->CloseUDPBindSession(service);
}
/** MCxg̃R[obN֐
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param ev MCxg
 * @param pParam MCxg̔ėpp[^(łCAquaMessageSystem̃CX^Xւ̃|C^ɂȂ܂)
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::cbfunc_Recv(AquaNetworkSystem::CAquaNetworkSession* session, short ev, void* pParam)
{
	CAquaMessageSystem* pAquaMessageSystem = (CAquaMessageSystem*)pParam;
	if(NULL == session) { return 0; }
	if(NULL == pAquaMessageSystem) { return 0; }

	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_READ) {
		unsigned char data[20000];
		memset(data, '\0', sizeof(data));
		int len = session->recv(data, sizeof(data), 0);
		if(0 < len) {
			pAquaMessageSystem->notify_session_event(session, ev);
			pAquaMessageSystem->parse_message(session, data, len);
		} else if(0 == len) {
			pAquaMessageSystem->notify_session_event(session, AQUAMESSYS_SESSION_EVENT_TYPE_FD_CLOSE);
			session->SetUsed(false);
		} else if(0 > len) {
			pAquaMessageSystem->notify_session_event(session, AQUAMESSYS_SESSION_EVENT_TYPE_FD_CLOSE);
			session->SetUsed(false);
		}
	} else {
		pAquaMessageSystem->notify_session_event(session, ev);
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_ACCEPT) {
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_CONNECT) {
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_CLOSE) {
		session->SetUsed(false);
	}
	return 1;
}
/** UDPMCxg̃R[obN֐
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param ev MCxg
 * @param pParam MCxg̔ėpp[^(łCAquaMessageSystem̃CX^Xւ̃|C^ɂȂ܂)
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::cbfunc_udp_Recv(AquaNetworkSystem::CAquaNetworkUDPSession* session, short ev, void* pParam)
{
	CAquaMessageSystem* pAquaMessageSystem = (CAquaMessageSystem*)pParam;
	if(NULL == session) { return 0; }
	if(NULL == pAquaMessageSystem) { return 0; }

	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_READ) {
		unsigned char data[20000];
		memset(data, '\0', sizeof(data));
		struct sockaddr_storage sa_storage;
		struct sockaddr* sa = (struct sockaddr*)&sa_storage;
		socklen_t salen = sizeof(sa_storage);
		int len = session->recvfrom(data, sizeof(data), 0, sa, &salen);
		if(0 < len) {
			pAquaMessageSystem->notify_udp_session_event(session, ev, sa, salen);
			pAquaMessageSystem->parse_udp_message(session, data, len, sa, salen);
		} else if(0 == len) {
			pAquaMessageSystem->notify_udp_session_event(session, AQUAMESSYS_SESSION_EVENT_TYPE_FD_CLOSE, sa, salen);
			session->SetUsed(false);
		} else if(0 > len) {
			pAquaMessageSystem->notify_udp_session_event(session, AQUAMESSYS_SESSION_EVENT_TYPE_FD_CLOSE, sa, salen);
			session->SetUsed(false);
		}
	} else {
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_ACCEPT) {
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_CONNECT) {
	}
	if(ev & AquaNetworkSystem::SESSION_EVENT_TYPE_FD_CLOSE) {
	}
	return 1;
}

/** ZbVCxgʒm
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param ev ʒmCxg
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::notify_session_event(AquaNetworkSystem::CAquaNetworkSession* session, short ev)
{
	struct sockaddr_storage	sa_storage;
	struct sockaddr* sa = (struct sockaddr*)&sa_storage;
	socklen_t salen = sizeof(sa_storage);
	session->GetSocketAddr(&sa_storage);

	char hostname[NI_MAXHOST];
	char service[NI_MAXSERV];
	addr2str(sa, salen, hostname, sizeof(hostname), service, sizeof(service));

	for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
		if(AQUAMESSYS_MESSAGE_TYPE_SESSION_EVENT != (*it).m_type) { continue; }
		if(sizeof(tagMessageDataSesssionEvent) < (*it).m_size) { continue; }
		tagMessageDataSesssionEvent MessageDataSesssionEvent;
		MessageDataSesssionEvent.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_SESSION_EVENT;
		MessageDataSesssionEvent.m_header.m_size = (unsigned short)(sizeof(tagMessageDataSesssionEvent));
		MessageDataSesssionEvent.m_ev = ev;
		memcpy(&(MessageDataSesssionEvent.m_SessionAddr), &sa_storage, salen);
		CAquaMessageSession message_session;
		message_session.attach_session(session);
		int iRet = (*it).m_call_func(&message_session, hostname, service, &MessageDataSesssionEvent, sizeof(tagMessageDataSesssionEvent));
		return 1;
	}
	return 1;
}
/** UDPZbVCxgʒm
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param ev ʒmCxg
 * @param sa M̃AhX
 * @param salen M̃AhX̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::notify_udp_session_event(AquaNetworkSystem::CAquaNetworkUDPSession* session, short ev, const struct sockaddr* sa, socklen_t salen)
{
	char hostname[NI_MAXHOST];
	char service[NI_MAXSERV];
	addr2str(sa, salen, hostname, sizeof(hostname), service, sizeof(service));

	for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
		if(AQUAMESSYS_MESSAGE_TYPE_SESSION_EVENT != (*it).m_type) { continue; }
		if(sizeof(tagMessageDataSesssionEvent) < (*it).m_size) { continue; }
		tagMessageDataSesssionEvent MessageDataSesssionEvent;
		MessageDataSesssionEvent.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_SESSION_EVENT;
		MessageDataSesssionEvent.m_header.m_size = (unsigned short)(sizeof(tagMessageDataSesssionEvent));
		MessageDataSesssionEvent.m_ev = ev;
		memcpy(&(MessageDataSesssionEvent.m_SessionAddr), sa, salen);
		CAquaMessageSession message_session;
		message_session.attach_udp_session(session);
		int iRet = (*it).m_call_func(&message_session, hostname, service, &MessageDataSesssionEvent, sizeof(tagMessageDataSesssionEvent));
		return 1;
	}
	return 1;
}
/** Mf[^̉͊֐
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param buf Mf[^
 * @param num Mf[^̃TCY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_message(AquaNetworkSystem::CAquaNetworkSession* session, const unsigned char* buf, int num)
{
	struct sockaddr_storage	sa_storage;
	struct sockaddr* sa = (struct sockaddr*)&sa_storage;
	socklen_t salen = sizeof(sa_storage);
	session->GetSocketAddr(&sa_storage);

	char hostname[NI_MAXHOST];
	char service[NI_MAXSERV];
	addr2str(sa, salen, hostname, sizeof(hostname), service, sizeof(service));

	size_t read_seek = 0;
	if(0 >= num) { return 0; }

	while((size_t)num > read_seek) {

		tagMessageHeader MessageHeader;
		memcpy(&MessageHeader, &(buf[read_seek]), sizeof(tagMessageHeader));
		
		// call function table
		struct {
			eAquaMessageSystemMessageType	m_type;
			int								(CAquaMessageSystem::*m_call_func)(class AquaNetworkSystem::CAquaNetworkSession* session, const void*, size_t);
			size_t							m_size;
		} call_func_table[] = {
			AQUAMESSYS_MESSAGE_TYPE_USER_AUTH_REQUSET,	&CAquaMessageSystem::parse_message_data_user_auth_request,	sizeof(tagMessageDataUserAuthRequest),
			AQUAMESSYS_MESSAGE_TYPE_USER_AUTH_RESULT,	&CAquaMessageSystem::parse_message_data_user_auth_result,	sizeof(tagMessageDataUserAuthResult),

//			AQUAMESSYS_MESSAGE_TYPE_USER_MESSAGE,		&CAquaMessageSystem::parse_message_data_user_message,		sizeof(tagMessageDataUserMessage),
//			AQUAMESSYS_MESSAGE_TYPE_USER_STATE,		&CAquaMessageSystem::parse_message_data_user_state,			sizeof(tagMessageDataUserState),
		};

		int iRet = 0;
		int array_num = ARRAY_NUM(call_func_table);
		bool bCallFunction = false;

		for(int i=0; i<array_num; i++) {
			if(MessageHeader.m_type != call_func_table[i].m_type ) { continue; }
			if(MessageHeader.m_size != call_func_table[i].m_size ) { continue; }
			if((sizeof(char) * (num - read_seek)) < call_func_table[i].m_size) { continue; }
			iRet = (this->*call_func_table[i].m_call_func)(session, &(buf[read_seek]), call_func_table[i].m_size);
			if(0 == iRet) { return 0; }
			bCallFunction = true;
			break;
		}
		if(bCallFunction) {
			read_seek += MessageHeader.m_size;
			continue;
		}

		if((AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_START <= MessageHeader.m_type) &&
			(AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_END >= MessageHeader.m_type)) {

			bCallFunction = false;

			// call ExtensionAllCallFunction
			for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
				if(AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_ALL != (*it).m_type) { continue; }
				CAquaMessageSession message_session;
				message_session.attach_session(session);
				iRet = (*it).m_call_func(&message_session, hostname, service, &(buf[read_seek]), MessageHeader.m_size);
			}

			// call ExtensionCallFunction
			for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
				if(MessageHeader.m_type != (*it).m_type) { continue; }
				if(MessageHeader.m_size != (*it).m_size ) { continue; }
				if((sizeof(char) * (num - read_seek)) < (*it).m_size) { continue; }
				CAquaMessageSession message_session;
				message_session.attach_session(session);
				iRet = (*it).m_call_func(&message_session, hostname, service, &(buf[read_seek]), (*it).m_size);
				bCallFunction = true;
			}

			if(bCallFunction) {
				read_seek += MessageHeader.m_size;
				continue;
			}

		}
		read_seek += MessageHeader.m_size;
	}

	return 1;

}
/** MbZ[Wf[^̉͊֐(Fؗv)
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param pMessageData MbZ[Wf[^
 * @param nMessageData MbZ[Wf[^̃TCY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_message_data_user_auth_request(AquaNetworkSystem::CAquaNetworkSession* session, const void* pMessageData, size_t nMessageData)
{

	// recv from auth request
	tagMessageDataUserAuthRequest MessageDataUserAuthRequest;
	memcpy(&MessageDataUserAuthRequest, pMessageData, sizeof(tagMessageDataUserAuthRequest));

	int result = 0;
	CAquaMessageUser* pAuthUser = m_mum_auth.get_user(MessageDataUserAuthRequest.m_uid, _tcscnlen(MessageDataUserAuthRequest.m_uid, sizeof(MessageDataUserAuthRequest.m_uid)));
	if(NULL != pAuthUser) {
		if(0 == ::_tcscmp(MessageDataUserAuthRequest.m_passwd, pAuthUser->get_passwd())) {
			result = 1;
		}
	}
	if(1 == result) {
		// add user
		this->add_user(MessageDataUserAuthRequest.m_uid, _tcscnlen(MessageDataUserAuthRequest.m_uid, sizeof(MessageDataUserAuthRequest.m_uid)), MessageDataUserAuthRequest.m_passwd, _tcscnlen(MessageDataUserAuthRequest.m_passwd, sizeof(MessageDataUserAuthRequest.m_passwd)));
		CAquaMessageUser* pAquaMessageUser = this->get_user(MessageDataUserAuthRequest.m_uid, _tcscnlen(MessageDataUserAuthRequest.m_uid, sizeof(MessageDataUserAuthRequest.m_uid)));
		if(NULL == pAquaMessageUser) {
			return 0;
		}
		session->attach_ExtensionObject(pAquaMessageUser);
	}

	// send to auth result
	tagMessageDataUserAuthResult MessageDataUserAuthResult;
	MessageDataUserAuthResult.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_USER_AUTH_RESULT;
	MessageDataUserAuthResult.m_header.m_size = (unsigned short)(sizeof(tagMessageDataUserAuthResult));
	MessageDataUserAuthResult.m_result = result;

	::_tcsncpy_s(MessageDataUserAuthResult.m_uid, sizeof(MessageDataUserAuthResult.m_uid), MessageDataUserAuthRequest.m_uid, _tcscnlen(MessageDataUserAuthRequest.m_uid, sizeof(MessageDataUserAuthRequest.m_uid)));
	::_tcsncpy_s(MessageDataUserAuthResult.m_passwd, sizeof(MessageDataUserAuthResult.m_passwd), MessageDataUserAuthRequest.m_passwd, _tcscnlen(MessageDataUserAuthRequest.m_passwd, sizeof(MessageDataUserAuthRequest.m_passwd)));

	session->send((const unsigned char*)&MessageDataUserAuthResult, sizeof(tagMessageDataUserAuthResult), 0);

	return 1;
}
/** MbZ[Wf[^̉͊֐(F،)
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param pMessageData MbZ[Wf[^
 * @param nMessageData MbZ[Wf[^̃TCY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_message_data_user_auth_result(AquaNetworkSystem::CAquaNetworkSession* session, const void* pMessageData, size_t nMessageData)
{
	if(NULL == m_nsm) { return 0; }
	// recv from auth result
	tagMessageDataUserAuthResult MessageDataUserAuthResult;
	memcpy(&MessageDataUserAuthResult, pMessageData, sizeof(tagMessageDataUserAuthResult));

	if(1 == MessageDataUserAuthResult.m_result) {
		// login ok -> add user
		this->add_user(MessageDataUserAuthResult.m_uid, _tcscnlen(MessageDataUserAuthResult.m_uid, sizeof(MessageDataUserAuthResult.m_uid)), MessageDataUserAuthResult.m_passwd, _tcscnlen(MessageDataUserAuthResult.m_passwd, sizeof(MessageDataUserAuthResult.m_passwd)));
	} else {
		m_nsm->Close(session);
	}

	return 1;
}
/** MbZ[Wf[^̉͊֐([UbZ[W)
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param pMessageData MbZ[Wf[^
 * @param nMessageData MbZ[Wf[^̃TCY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_message_data_user_message(AquaNetworkSystem::CAquaNetworkSession* session, const void* pMessageData, size_t nMessageData)
{
	// recv from user message
	tagMessageDataUserMessage MessageDataUserMessage;
	memcpy(&MessageDataUserMessage, pMessageData, sizeof(tagMessageDataUserMessage));
	return 1;
}
/** MbZ[Wf[^̉͊֐([U)
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param pMessageData MbZ[Wf[^
 * @param nMessageData MbZ[Wf[^̃TCY
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_message_data_user_state(AquaNetworkSystem::CAquaNetworkSession* session, const void* pMessageData, size_t nMessageData)
{
	// recv from user state
	tagMessageDataUserState MessageDataUserState;
	memcpy(&MessageDataUserState, pMessageData, sizeof(tagMessageDataUserState));
	return 1;
}/** UDPMf[^̉͊֐
 * @param session ZbVNX̃IuWFNgւ̃|C^
 * @param buf Mf[^
 * @param num Mf[^̃TCY
 * @param sa M̃AhX
 * @param salen M̃AhX̒
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::parse_udp_message(AquaNetworkSystem::CAquaNetworkUDPSession* session, const unsigned char* buf, int num, const struct sockaddr* sa, socklen_t salen)
{
	char hostname[NI_MAXHOST];
	char service[NI_MAXSERV];
	addr2str(sa, salen, hostname, sizeof(hostname), service, sizeof(service));

	tagMessageHeader MessageHeader;
	memcpy(&MessageHeader, buf, sizeof(tagMessageHeader));
	
	int iRet = 0;
	// call ExtensionCallFunction
	for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
		if(MessageHeader.m_type != (*it).m_type) { continue; }
		if((sizeof(char) * num) < (*it).m_size) { continue; }
		CAquaMessageSession message_session;
		message_session.attach_udp_session(session);
		iRet = (*it).m_call_func(&message_session, hostname, service, buf, (*it).m_size);
		return 1;
	}

	return 1;

}
/** gbZ[Wf[^ǉ
 * @param ExtensionCallFunction ǉgbZ[Wf[^ւ̎Q
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::add_ExtensionCallFunction(const tagExtensionCallFunction& ExtensionCallFunction)
{
	m_ExtensionCallFunctionArray.push_back(ExtensionCallFunction);
	return 1;
}
/** w肵gbZ[Wf[^폜
 * @param type 폜ǉgbZ[Wf[^̎
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::delete_ExtensionCallFunction(int type)
{
	for(std::vector<tagExtensionCallFunction>::iterator it=m_ExtensionCallFunctionArray.begin(); it!=m_ExtensionCallFunctionArray.end(); it++) {
		if((*it).m_type != type) { continue; }
		it = m_ExtensionCallFunctionArray.erase(it);
		return 1;
	}
	return 0;
}
/** SgbZ[Wf[^폜
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaMessageSystem::delete_allExtensionCallFunction(void)
{
	m_ExtensionCallFunctionArray.clear();
	return 1;
}

}

using namespace AquaMessageSystem;

extern "C" {
	/** CAquaMessageSystemNXIuWFNg̐
	 * @retval NXIuWFNgւ̃|C^(sNULLԂ܂)
	 */
	CAquaMessageSystem* AquaMessageSystemCreate()
	{
		return new CAquaMessageSystem;
	}

}
#ifdef WIN32
bool WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	switch(fdwReason) {
	case DLL_PROCESS_ATTACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	}
	return true;
}
#endif // WIN32


