/** 
 * @file  AquaNetworkSystem.cpp
 * @brief lbg[NVXeNX\[Xt@C
 * @note lbg[Nւ鏈s܂<br>
 * @date 2008/03/14
 */
#ifdef WIN32
#define _CRT_SECURE_NO_DEPRECATE		// n֐̃ZLeBɊւx̗}p(.net2005ȍ~̑Ώ)
#endif // WIN32

static char Copyright[] = "AquaNetworkSystem Copyright (c) 2008-2009 AquaSystem Project.";
static char Version[] = "AquaNetworkSystem Version 2.00.0";

#ifdef WIN32
#include <process.h>
#include <tchar.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#else // WIN32
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <errno.h>
#endif // WIN32

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <new>

#include "AquaNetworkSystem.h"
#include "CryptFunction.h"

#ifdef WIN32
//#pragma comment(lib, "ws2_32.lib")
//#pragma comment(lib, "User32.lib")
typedef unsigned THREADID;
typedef unsigned (WINAPI *THREADFUNC)(LPVOID);
#endif // WIN32

#ifdef USEING_WINSOCK_SELECT
#define WM_SOCKET	WM_USER + 1			/* \PbgCxgʒm郁bZ[W */
LRESULT CALLBACK WinSockProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
#endif // USEING_WINSOCK_SELECT


#ifndef WIN32
#define closesocket			::close
#define _snprintf			::snprintf
#endif // WIN32

/// vgRo[W 
#define MAJOR_PROTOCOL_VERSION		0x02	/// 20090109 last update	
#define MINER_PROTOCOL_VERSION		0x00

#ifdef WIN32
LPTSTR PrintError(int ErrorCode)
{
    static TCHAR Message[1024];

    // If this program was multi-threaded, we'd want to use
    // FORMAT_MESSAGE_ALLOCATE_BUFFER instead of a static buffer here.
    // (And of course, free the buffer when we were done with it)

    FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS |
                  FORMAT_MESSAGE_MAX_WIDTH_MASK,
                  NULL, ErrorCode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
                  (LPTSTR) Message, 1024, NULL);
    return Message;
}
#endif // WIN32
int nslookup(const char* hostname, struct in_addr *ipaddr)
{
	struct in_addr iaHost, *alist;
	struct hostent *lpHostEntry;
	int i;

	// convert string to IP-address(u_long)
	iaHost.s_addr = inet_addr(hostname);
	if(INADDR_NONE != iaHost.s_addr) {
		*ipaddr = iaHost;
		return 0;
	}

	// lookup DNS; hostname -> IP-address
	lpHostEntry = gethostbyname(hostname);
	if(NULL == lpHostEntry) {	// DNS error?
#ifdef WIN32
//		printf("Can't nslookup hostname(%s) %d\n", hostname, WSAGetLastError());
#endif // WIN32
		return 0;
	}

	for(i=0; ; i++) {
		alist = (struct in_addr *)lpHostEntry->h_addr_list[i];
		if(NULL == alist) { break; }
//		printf("%s\n", inet_ntoa(*alist));
		*ipaddr = *alist;
	}
	if(i == 0) {
//		printf("Can't get IP-address\n");
		return 0;
	}
	return 1;
}
static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host_str, size_t host_strlen)
{
	if(NULL == sa) { return; }

	char host[NI_MAXHOST] = "";
	char serv[NI_MAXSERV] = "";
	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv6)", host, serv);
		} else {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv4)", host, serv);
		} else {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host_str, host_strlen, "unknown");
	} else {
		_snprintf(host_str, host_strlen, "unknown");
	}
}
static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host, size_t hostlen, char* serv, size_t servlen)
{
	if(NULL == sa) { return; }
	if(NULL == host) { return; }
	if(NULL == serv) { return; }

	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
//			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	} else {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	}
}

namespace AquaNetworkSystem {

static int GetCryptoKeyLength(eCryptoAlgorithm CryptoAlgorithm)
{
	switch(CryptoAlgorithm) {
	case CRYPTO_ALGORITHM_NONE:	return 0;
	case CRYPTO_ALGORITHM_3DES:	return get_key_length_DES_EDE3();
	case CRYPTO_ALGORITHM_BLOWFISH:	return get_key_length_BF();
	default: return 0;
	}
}
static int GetCryptoIVLength(eCryptoAlgorithm CryptoAlgorithm)
{
	switch(CryptoAlgorithm) {
	case CRYPTO_ALGORITHM_NONE:	return 0;
	case CRYPTO_ALGORITHM_3DES:	return get_iv_length_DES_EDE3();
	case CRYPTO_ALGORITHM_BLOWFISH:	return get_iv_length_BF();
	default: return 0;
	}
}

//==============================================
// class CAquaNetworkSession
//==============================================
CAquaNetworkSession::CAquaNetworkSession()
{
	m_ConnectSocket = -1;
	m_SokcetState = SOCKET_STATE_NORMAL;

#ifdef USEING_LIBEVENT
	m_bConnectLibEventReadFlag = false;
	m_bConnectLibEventWriteFlag = false;
#endif // USEING_LIBEVENT

	m_bUsed = false;

	memset(m_recv_socket_buffer, 0, sizeof(m_recv_socket_buffer));
	m_recv_socket_buffer_read_point = 0;
	m_recv_socket_buffer_write_point = 0;
	memset(m_recv_buffer, 0, sizeof(m_recv_buffer));
	m_recv_buffer_read_point = 0;
	m_recv_buffer_write_point = 0;
	memset(m_send_buffer, 0, sizeof(m_send_buffer));
	m_send_buffer_read_point = 0;
	m_send_buffer_write_point = 0;
		
	m_cbfunc_Event = NULL;
	m_cbfunc_EventParam = NULL;
	m_ExtensionObject = NULL;

	m_CryptoAlgorithm = CRYPTO_ALGORITHM_NONE;
	m_CryptoStateRecv = CRYPTO_STATE_PLAIN;
	m_CryptoStateSend = CRYPTO_STATE_PLAIN;

	memset(m_CryptoKey, 0, sizeof(m_CryptoKey));
	m_CryptoKeyLength = 0;
	memset(m_CryptoIV, 0, sizeof(m_CryptoIV));
	m_CryptoIVLength = 0;
	memset(m_RSAPrivateKey, 0, sizeof(m_RSAPrivateKey));
	m_RSAPrivateKeyLength = 0;
	memset(m_RSAPublicKey, 0, sizeof(m_RSAPublicKey));
	m_RSAPublicKeyLength = 0;
	m_RSAPublicExponent = 0;
}
CAquaNetworkSession::~CAquaNetworkSession()
{
	SetUsed(false);
}
/// gptO擾
bool CAquaNetworkSession::IsUsed() const
{
	return m_bUsed;
}
/// gptOݒ
void CAquaNetworkSession::SetUsed(bool bFlag)
{
	m_bUsed = bFlag;

	if(!m_bUsed) {
		close();
		memset(m_recv_socket_buffer, 0, sizeof(m_recv_socket_buffer));
		m_recv_socket_buffer_read_point = 0;
		m_recv_socket_buffer_write_point = 0;
		memset(m_recv_buffer, 0, sizeof(m_recv_buffer));
		m_recv_buffer_read_point = 0;
		m_recv_buffer_write_point = 0;
		memset(m_send_buffer, 0, sizeof(m_send_buffer));
		m_send_buffer_read_point = 0;
		m_send_buffer_write_point = 0;
		m_cbfunc_Event = NULL;
		m_cbfunc_EventParam = NULL;
		m_CryptoAlgorithm = CRYPTO_ALGORITHM_NONE;
		m_CryptoStateRecv = CRYPTO_STATE_PLAIN;
		m_CryptoStateSend = CRYPTO_STATE_PLAIN;

		memset(m_CryptoKey, 0, sizeof(m_CryptoKey));
		m_CryptoKeyLength = 0;
		memset(m_CryptoIV, 0, sizeof(m_CryptoIV));
		m_CryptoIVLength = 0;
		memset(m_RSAPrivateKey, 0, sizeof(m_RSAPrivateKey));
		m_RSAPrivateKeyLength = 0;
		memset(m_RSAPublicKey, 0, sizeof(m_RSAPublicKey));
		m_RSAPublicKeyLength = 0;
		m_RSAPublicExponent = 0;
	}
}
/// \Pbg擾
SOCKET CAquaNetworkSession::GetSocket(void)
{
	return m_ConnectSocket;
}
/// \Pbg擾(const)
SOCKET CAquaNetworkSession::GetSocket(void) const
{
	return m_ConnectSocket;
}
/// \PbgAhX擾
struct sockaddr* CAquaNetworkSession::GetSocketAddr(struct sockaddr_storage* pSocketAddr) const
{
	if(NULL != pSocketAddr) {
		memcpy(pSocketAddr, &(this->m_ConnectAddr), sizeof(struct sockaddr_storage));
	}
	struct sockaddr* sa = (struct sockaddr*)&(this->m_ConnectAddr);
	return sa;
}
#ifdef USEING_LIBEVENT
/// MCxg̐ݒ
void CAquaNetworkSession::SetLibEventRead(short libevent, void(*fn)(int, short, void *), void* arg)
{
	return event_set(&m_ConnectLibEventRead, m_ConnectSocket, libevent, fn, arg);
}
/// MCxg̒ǉ
int CAquaNetworkSession::AddLibEventRead(struct timeval* tv)
{
	m_bConnectLibEventReadFlag = true;
	return event_add(&m_ConnectLibEventRead, tv);
}
/// MCxg̍폜
int CAquaNetworkSession::DelLibEventRead(void)
{
	if(m_bConnectLibEventReadFlag) {
		m_bConnectLibEventReadFlag = false;
		return event_del(&m_ConnectLibEventRead);
	}
	return -1;
}
/// MCxg̐ݒ
void CAquaNetworkSession::SetLibEventWrite(short libevent, void(*fn)(int, short, void *), void* arg)
{
	return event_set(&m_ConnectLibEventWrite, m_ConnectSocket, libevent, fn, arg);
}
/// MCxg̒ǉ
int CAquaNetworkSession::AddLibEventWrite(struct timeval* tv)
{
	m_bConnectLibEventWriteFlag = true;
	return event_add(&m_ConnectLibEventWrite, tv);
}
/// MCxg̍폜
int CAquaNetworkSession::DelLibEventWrite(void)
{
	if(m_bConnectLibEventWriteFlag) {
		m_bConnectLibEventWriteFlag = false;
		return event_del(&m_ConnectLibEventWrite);
	}
	return -1;
}
#endif // USEING_LIBEVENT

/// ZbV̐ڑM
SOCKET CAquaNetworkSession::accept(CAquaNetworkSessionListen* pAquaNetworkSessionListen)
{
	if(NULL == pAquaNetworkSessionListen) { return -1; }

	socklen_t socklen = sizeof(this->m_ConnectAddr);
	struct sockaddr* sa = (struct sockaddr*)&(this->m_ConnectAddr);

	SOCKET connect_socket = pAquaNetworkSessionListen->Accept(sa, &socklen);

	if(INVALID_SOCKET == connect_socket) { return -1; }
	m_ConnectSocket = connect_socket;
	m_cbfunc_Event = pAquaNetworkSessionListen->Get_cbfunc_Event();
	m_cbfunc_EventParam = pAquaNetworkSessionListen->Get_cbfunc_EventParam();

	struct sockaddr_in addr;
	memcpy(&addr, (struct sockaddr_in *)&m_ConnectAddr, sizeof(struct sockaddr_in));
	unsigned char ipv4[4];
	memcpy(ipv4, &(addr.sin_addr.s_addr), sizeof(ipv4));
//	_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr) - 1, "0.0.0.0");
//	_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr) - 1, "%d.%d.%d.%d", ipv4[0], ipv4[1], ipv4[2], ipv4[3]);

	// RSA𕡐(Listensession)
	unsigned char RSAPrivateKey[RSA_MAX_KEY_LENGTH];
	int RSAPrivateKeyLength;
	unsigned char RSAPublicKey[RSA_MAX_KEY_LENGTH];
	int RSAPublicKeyLength;
	RSAPrivateKeyLength = pAquaNetworkSessionListen->GetRSAPrivateKey(RSAPrivateKey, sizeof(RSAPrivateKey));
	if(0 < RSAPrivateKeyLength) {
		SetRSAPrivateKey(RSAPrivateKey, sizeof(unsigned char) * RSAPrivateKeyLength);
	}
	RSAPublicKeyLength = pAquaNetworkSessionListen->GetRSAPublicKey(RSAPublicKey, sizeof(RSAPublicKey));
	if(0 < RSAPublicKeyLength) {
		SetRSAPublicKey(RSAPublicKey, sizeof(unsigned char) * RSAPublicKeyLength);
	}
	SetRSAPublicExponent(pAquaNetworkSessionListen->GetRSAPublicExponent());

	return m_ConnectSocket;
}
/// ZbV̐ڑ
SOCKET CAquaNetworkSession::connect(bool bSecure, const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	if(NULL == hostname) { return SOCKET_ERROR; }
	if(0 == service) { return SOCKET_ERROR; }

	struct addrinfo hints;
	struct addrinfo* res = NULL;
	struct addrinfo* ai;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;

	if(0 != getaddrinfo(hostname, service, &hints, &res)) {
		return INVALID_SOCKET;
	}
	
	SOCKET connect_socket = INVALID_SOCKET;
	for (ai = res; ai; ai = ai->ai_next) {
		connect_socket = ::socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
		if(connect_socket == INVALID_SOCKET){
			freeaddrinfo(res);
//			printf("Can't create socket\n");
			return INVALID_SOCKET;
		}

		if(SOCKET_ERROR == ::connect(connect_socket, ai->ai_addr, ai->ai_addrlen)) {
			closesocket(connect_socket);
			connect_socket = INVALID_SOCKET;
#ifdef WIN32
			TCHAR szMessage[1024];
			int error_code = WSAGetLastError();
			_sntprintf(szMessage, sizeof(szMessage), _T("%s (code=%d)"), PrintError(error_code), error_code);
			::MessageBox(NULL, szMessage, _T("Winsock Error"), MB_OK | MB_ICONWARNING);
#endif // WIN32

			continue;
		}
		memcpy(&m_ConnectAddr, ai->ai_addr, ai->ai_addrlen);
		m_ConnectSocket = connect_socket;
		m_cbfunc_Event = cbfunc_Event;
		m_cbfunc_EventParam = cbfunc_EventParam;
		m_SokcetState = SOCKET_STATE_NORMAL;
		break;
	}
	freeaddrinfo(res);
	if(connect_socket == INVALID_SOCKET){
		return INVALID_SOCKET;
	}

	if(bSecure) {
		// nhVF[NbZ[W(ClientHello)𑗐M
		if(0 > SendHandShakeClientHello()) {
			closesocket(connect_socket);
			return INVALID_SOCKET;
		}
	}

	char host[NI_MAXHOST] = "";
	char serv[NI_MAXSERV] = "";

	if(AF_INET6 == m_ConnectAddr.ss_family) {
		// ipv6
		struct sockaddr_in6 addr_in6;
		memcpy(&addr_in6, &m_ConnectAddr, sizeof(struct sockaddr_in6));
		if(0 == getnameinfo((struct sockaddr *)&addr_in6, sizeof(addr_in6), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV)) {
//			memset(m_ConnectAddrStr, '\0', sizeof(m_ConnectAddrStr));
//			_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr), "%s:%s(ipv6)", host, serv);
		} else {
//			memset(m_ConnectAddrStr, '\0', sizeof(m_ConnectAddrStr));
//			_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr), "unknown");
		}
	} else if(AF_INET == m_ConnectAddr.ss_family) {
		// ipv4
		struct sockaddr_in addr_in;
		memcpy(&addr_in, &m_ConnectAddr, sizeof(struct sockaddr_in));
		if(0 == getnameinfo((struct sockaddr *)&addr_in, sizeof(addr_in), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV)) {
//			memset(m_ConnectAddrStr, '\0', sizeof(m_ConnectAddrStr));
//			_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr), "%s:%s(ipv4)", host, serv);
		} else {
//			memset(m_ConnectAddrStr, '\0', sizeof(m_ConnectAddrStr));
//			_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr), "unknown");
		}
	} else {
//		memset(m_ConnectAddrStr, '\0', sizeof(m_ConnectAddrStr));
//		_sntprintf(m_ConnectAddrStr, sizeof(m_ConnectAddrStr), "unknown");
	}

//	printf("Connect to server\n");

	// connectCxg𔭍s
	this->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_CONNECT);
	return m_ConnectSocket;
}
/// ZbV̐ڑ
SOCKET CAquaNetworkSession::connect(const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	return connect(false, hostname, service, cbfunc_Event, cbfunc_EventParam);
}
/// ZbV̐ڑ
SOCKET CAquaNetworkSession::connect_secure(const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	return connect(true, hostname, service, cbfunc_Event, cbfunc_EventParam);
}
/// ZbV̐ؒf
void CAquaNetworkSession::close(void)
{
	if(0 < m_ConnectSocket) {
#ifdef USEING_LIBEVENT
		this->DelLibEventRead();
		this->DelLibEventWrite();
#endif // USEING_LIBEVENT
		closesocket(m_ConnectSocket);
		m_ConnectSocket = -1;
		m_SokcetState = SOCKET_STATE_NORMAL;
	}
}

/** MOobt@̏݃TCY擾
 * @retval MOobt@̋󂫃TCY
 */
size_t CAquaNetworkSession::get_recv_socket_buffer_size(void)
{
	size_t free_size = 0;
//	size_t write_size = m_recv_socket_buffer_write_point - m_recv_socket_buffer_read_point;
//	if(0 > write_size) {
//		write_size += RECV_BUFFER_SIZE_DEFALUT;
//	}
	size_t write_size = 0;
	if(m_recv_socket_buffer_write_point >= m_recv_socket_buffer_read_point) {
		write_size = m_recv_socket_buffer_write_point - m_recv_socket_buffer_read_point;
	} else {
		write_size = m_recv_socket_buffer_write_point + RECV_BUFFER_SIZE_DEFALUT - m_recv_socket_buffer_read_point;
	}

	return write_size;
}
/** MOobt@̋󂫂擾
 * @retval MOobt@̋󂫃TCY
 */
size_t CAquaNetworkSession::get_recv_socket_buffer_free(void)
{
	size_t free_size = 0;
	size_t write_size = get_recv_socket_buffer_size();
	// 󂫗̈`FbN
	free_size = RECV_BUFFER_SIZE_DEFALUT - write_size - 1;
	return free_size;
}
/// M֐
int CAquaNetworkSession::recv(void)
{
	unsigned char recv_data[RECV_BUFFER_SIZE_DEFALUT];
	int recv_data_length = ::recv(m_ConnectSocket, (char*)recv_data, get_recv_socket_buffer_free(), 0);
	if(0 > recv_data_length) {
		// \PbgG[
		// ܂freesG[̉\
		m_SokcetState = SOCKET_STATE_ERROR;
		return recv_data_length;
	}
	if(0 == recv_data_length) {
		// \PbgN[Y
		m_SokcetState = SOCKET_STATE_CONNECTION_CLOSE;
		return recv_data_length;
	}

	if(RECV_BUFFER_SIZE_DEFALUT <= m_recv_socket_buffer_write_point + recv_data_length) {
		size_t cpy_size1 = RECV_BUFFER_SIZE_DEFALUT - m_recv_socket_buffer_write_point;
		size_t cpy_size2 = recv_data_length - cpy_size1;
		memcpy(&(m_recv_socket_buffer[m_recv_socket_buffer_write_point]), &(recv_data[0]), sizeof(unsigned char) * cpy_size1);
		memcpy(&(m_recv_socket_buffer[0]), &(recv_data[cpy_size1]), sizeof(unsigned char) * cpy_size2);
		m_recv_socket_buffer_write_point = cpy_size2;
		
	} else {
		memcpy(&(m_recv_socket_buffer[m_recv_socket_buffer_write_point]), recv_data, sizeof(unsigned char) * recv_data_length);
		m_recv_socket_buffer_write_point += recv_data_length;
	}
	return recv_data_length;
}


/// MOobt@f[^o
int CAquaNetworkSession::parse_recv_socket_buffer(void)
{

	m_LastRecvCryptoMessages.clear();

	unsigned char* recv_socket_buffer_ptr = (&(m_recv_socket_buffer[m_recv_socket_buffer_read_point]));
	size_t recv_socket_buffer_size = get_recv_socket_buffer_size();
	unsigned char recv_socket_buffer_work[RECV_BUFFER_SIZE_DEFALUT];
	memset(recv_socket_buffer_work, 0, sizeof(recv_socket_buffer_work));
	size_t recv_socket_buffer_work_seek = 0;

	if(RECV_BUFFER_SIZE_DEFALUT <= m_recv_socket_buffer_read_point + recv_socket_buffer_size) {
		// Oobt@܂Ԃ
		size_t cpy_size1 = RECV_BUFFER_SIZE_DEFALUT - m_recv_socket_buffer_read_point;
		size_t cpy_size2 = recv_socket_buffer_size - cpy_size1;
		// TLSpPbgMobt@֊i[
		memcpy(&(recv_socket_buffer_work[0]), recv_socket_buffer_ptr, sizeof(unsigned char) * cpy_size1);
		memcpy(&(recv_socket_buffer_work[cpy_size1]), m_recv_socket_buffer, sizeof(unsigned char) * cpy_size2);
	} else {
		// TLSpPbgMobt@֊i[
		memcpy(recv_socket_buffer_work, recv_socket_buffer_ptr, sizeof(unsigned char) * recv_socket_buffer_size);
	}

	// f[^pwb_ǂݍނߎMς݃f[^TCYwb_TCYȏKv
	if(sizeof(tagDataHeader) > recv_socket_buffer_size) {
		return 0;
	}

	while(recv_socket_buffer_work_seek < recv_socket_buffer_size) {

		tagDataHeader DataHeader;
		memset(&DataHeader, 0, sizeof(tagDataHeader));

		// f[^
		memcpy(&(DataHeader.m_CryptoMessageType), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_CryptoMessageType));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_CryptoMessageType);

		/// vgRo[W
		memcpy(&(DataHeader.m_MajorProtocolVersion), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_MajorProtocolVersion));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_MajorProtocolVersion);
		memcpy(&(DataHeader.m_MinerProtocolVersion), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_MinerProtocolVersion));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_MinerProtocolVersion);

		// f[^
		memcpy(&(DataHeader.m_body_length_high), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_body_length_high));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_body_length_high);
		memcpy(&(DataHeader.m_body_length_mid), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_body_length_mid));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_body_length_mid);
		memcpy(&(DataHeader.m_body_length_low), &(recv_socket_buffer_work[recv_socket_buffer_work_seek]), sizeof(DataHeader.m_body_length_low));
		recv_socket_buffer_work_seek += sizeof(DataHeader.m_body_length_low);

		char body[AQUA_NETWORK_RECVLEN_MAX];
		memset(body, 0, sizeof(body));
		size_t body_length = 0;
		body_length += (size_t)(DataHeader.m_body_length_high * 0x010000);
		body_length += (size_t)(DataHeader.m_body_length_mid  * 0x000100);
		body_length += (size_t)(DataHeader.m_body_length_low);

		// o͎Mς݃f[^TCYwb_TCY+{̃TCYȏKv
		if(sizeof(tagDataHeader) + body_length > recv_socket_buffer_size) {
			break;
		}

		int iRet = parse_recv_socket_buffer_sub(DataHeader, &(recv_socket_buffer_work[recv_socket_buffer_work_seek]));
		if(0 > iRet) {
			m_SokcetState = SOCKET_STATE_ERROR;
			return -1;
		}
		recv_socket_buffer_work_seek += body_length;

		// ôœǂݍ݈ʒuXV
		if(RECV_BUFFER_SIZE_DEFALUT <= m_recv_socket_buffer_read_point + sizeof(tagDataHeader) + body_length) {
			// Oobt@܂Ԃ
			size_t cpy_size1 = RECV_BUFFER_SIZE_DEFALUT - m_recv_socket_buffer_read_point;
			size_t cpy_size2 = (sizeof(tagDataHeader) + body_length) - cpy_size1;
			m_recv_socket_buffer_read_point = cpy_size2;
		} else {
			// TLSpPbgMobt@֊i[
			m_recv_socket_buffer_read_point += sizeof(tagDataHeader) + body_length;
		}
		m_LastRecvCryptoMessages.push_back((eCryptoMessageType)(DataHeader.m_CryptoMessageType));
	}

	return (int)recv_socket_buffer_work_seek;
}
/// M֐
int CAquaNetworkSession::parse_recv_socket_buffer_sub(const tagDataHeader& DataHeader, const unsigned char* Body)
{
	int DataHeader_body_length = 0;
	DataHeader_body_length += (int)(DataHeader.m_body_length_high * 0x010000);
	DataHeader_body_length += (int)(DataHeader.m_body_length_mid  * 0x000100);
	DataHeader_body_length += (int)(DataHeader.m_body_length_low);

	int body_length = 0;
	char unsigned body[AQUA_NETWORK_RECVLEN_MAX];
	memset(body, 0, sizeof(body));

	// Í̗LmF
	if(CRYPTO_STATE_CRYPTOED != GetCryptoStateRecv()) {
		memcpy(body, Body, sizeof(unsigned char) * DataHeader_body_length);
		body_length = DataHeader_body_length;
	} else {
		// ʌ擾
		unsigned char CryptoKey[EVP_MAX_KEY_LENGTH];
		int CryptoKeyLength = GetCryptoKey(CryptoKey, sizeof(CryptoKey));
		if(0 > CryptoKeyLength) { return -1; }
		// xNg擾
		unsigned char CryptoIV[EVP_MAX_IV_LENGTH];
		int CryptoIVLength = GetCryptoIV(CryptoIV, sizeof(CryptoIV));
		if(0 > CryptoIVLength) { return -1; }

		int decrypt_length = DataHeader_body_length;
		switch(GetCryptoAlgorithm()) {
		case CRYPTO_ALGORITHM_NONE:
			memcpy(body, Body, sizeof(unsigned char) * DataHeader_body_length);
			body_length = DataHeader_body_length;
			break;
		case CRYPTO_ALGORITHM_3DES:
			decrypt_length = decrypt_DES_EDE3((unsigned char*)body, sizeof(body), Body, sizeof(unsigned char) * DataHeader_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
			if(0 == decrypt_length) {
				return -1;
			}
			body_length = decrypt_length;
			break;
		case CRYPTO_ALGORITHM_BLOWFISH:
			decrypt_length = decrypt_BF((unsigned char*)body, sizeof(body), Body, sizeof(unsigned char) * DataHeader_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
			if(0 == decrypt_length) {
				return -1;
			}
			body_length = decrypt_length;
			break;
		}
	}
	int size = 0;
	switch(DataHeader.m_CryptoMessageType) {
	case CRYPTO_MES_TYPE_PLAIN:
		if(0 >= body_length) { break; }
		size = Plain(DataHeader, body);
		if(0 > size) { return size; }
		break;
	case CRYPTO_MES_TYPE_HANDSHAKE:
		if(0 >= body_length) { break; }
		size = HandShake(DataHeader, body);
		if(0 > size) { return size; }
		break;
	case CRYPTO_MES_TYPE_CHANGE_CIPHER_SPEC:
		if(0 >= body_length) { break; }
		size = ChangeCipherSpec(DataHeader, body);
		if(0 > size) { return size; }
		break;
	case CRYPTO_MES_TYPE_CRYPTOED:
		if(0 >= body_length) { break; }
		size = Cryptoed(DataHeader, body);
		if(0 > size) { return size; }
		break;
	default:
		return -1;
		break;
	}
	return size;
}

/** MOobt@̏݃TCY擾
 * @retval MOobt@̋󂫃TCY
 */
size_t CAquaNetworkSession::get_recv_buffer_size(void)
{
	size_t free_size = 0;
//	size_t write_size = m_recv_buffer_write_point - m_recv_buffer_read_point;
//	if(0 > write_size) {
//		write_size += RECV_BUFFER_SIZE_DEFALUT;
//	}
	size_t write_size = 0;
	if(m_recv_buffer_write_point >= m_recv_buffer_read_point) {
		write_size = m_recv_buffer_write_point - m_recv_buffer_read_point;
	} else {
		write_size = m_recv_buffer_write_point + RECV_BUFFER_SIZE_DEFALUT - m_recv_buffer_read_point;
	}
	return write_size;
}
/** MOobt@̋󂫂擾
 * @retval MOobt@̋󂫃TCY
 */
size_t CAquaNetworkSession::get_recv_buffer_free(void)
{
	size_t free_size = 0;
	size_t write_size = get_recv_buffer_size();
	// 󂫗̈`FbN
	free_size = RECV_BUFFER_SIZE_DEFALUT - write_size - 1;
	return free_size;
}
/// MOobt@ɒǋL
size_t CAquaNetworkSession::push_recv_buffer(const unsigned char* buffer, size_t size)
{
	if(NULL == buffer) { return 0; }
	if(0 >= size) { return 0; }

	// 󂫗̈`FbN
	size_t free_size = get_recv_buffer_free();
	if(size > free_size) { 
		return 0;
	}
	if(RECV_BUFFER_SIZE_DEFALUT <= m_recv_buffer_write_point + size) {
		size_t cpy_size1 = RECV_BUFFER_SIZE_DEFALUT - m_recv_buffer_write_point;
		size_t cpy_size2 = size - cpy_size1;
		memcpy(&(m_recv_buffer[m_recv_buffer_write_point]), &(buffer[0]), sizeof(unsigned char) * cpy_size1);
		memcpy(&(m_recv_buffer[0]), &(buffer[cpy_size1]), sizeof(unsigned char) * cpy_size2);
		m_recv_buffer_write_point = cpy_size2;
		
	} else {
		memcpy(&(m_recv_buffer[m_recv_buffer_write_point]), buffer, sizeof(unsigned char) * size);
		m_recv_buffer_write_point += size;
	}
	return size;
}
/// MOobt@f[^o
size_t CAquaNetworkSession::pop_recv_buffer(unsigned char* buffer, size_t size)
{
	if(NULL == buffer) { return 0; }
	if(0 >= size) { return 0; }
	
	// obt@̓ǂݍݐ擪ʒu
	unsigned char* recv_buffer_ptr = (&(m_recv_buffer[m_recv_buffer_read_point]));

	size_t write_size = get_recv_buffer_size();
	// ۂɓǂݍރobt@TCY
	if(size < write_size) {
		// SĂ݂̏ǂݍ܂Ȃ
		write_size = size;
	} else {
		// SĂ݂̏ǂݍ
	}

	if(RECV_BUFFER_SIZE_DEFALUT <= m_recv_buffer_read_point + write_size) {
		// Oobt@܂Ԃ
		size_t cpy_size1 = RECV_BUFFER_SIZE_DEFALUT - m_recv_buffer_read_point;
		size_t cpy_size2 = write_size - cpy_size1;
		// TLSpPbgMobt@֊i[
		memcpy(&(buffer[0]), recv_buffer_ptr, sizeof(unsigned char) * cpy_size1);
		memcpy(&(buffer[cpy_size1]), m_recv_buffer, sizeof(unsigned char) * cpy_size2);
		m_recv_buffer_read_point = cpy_size2;
	} else {
		// TLSpPbgMobt@֊i[
		memcpy(buffer, recv_buffer_ptr, sizeof(unsigned char) * write_size);
		m_recv_buffer_read_point += write_size;
	}
	return write_size;
}
/// M֐
int CAquaNetworkSession::recv(unsigned char* buf, int num, int flags)
{
	if(SOCKET_STATE_ERROR == m_SokcetState) {
		return -1;
	}
	if(SOCKET_STATE_CONNECTION_CLOSE == m_SokcetState) {
		return 0;
	}
	return (int)(pop_recv_buffer(buf, num));
}
// Mf[^iÍf[^j
int CAquaNetworkSession::Plain(const tagDataHeader& DataHeader, const unsigned char* body)
{
	if(NULL == body) { return -1; }
	int body_length = 0;
	body_length += (int)(DataHeader.m_body_length_high * 0x010000);
	body_length += (int)(DataHeader.m_body_length_mid  * 0x000100);
	body_length += (int)(DataHeader.m_body_length_low);
	if(0 > body_length) { return -1; }
	if(0 == body_length) { return 0; }
	size_t push_size = push_recv_buffer(body, body_length);
	return ((int)push_size);
}
// Mf[^inhVF[Nj
int	CAquaNetworkSession::HandShake(const tagDataHeader& DataHeader, const unsigned char* body)
{
	int body_length = 0;
	body_length += (int)(DataHeader.m_body_length_high * 0x010000);
	body_length += (int)(DataHeader.m_body_length_mid  * 0x000100);
	body_length += (int)(DataHeader.m_body_length_low);

	// HandShakewb_TCYȏォǂ
	if(sizeof(tagHandShakeHeader) > body_length) {
		return -1;
	}

	tagHandShakeHeader HandShakeHeader;
	memset(&HandShakeHeader, 0, sizeof(tagHandShakeHeader));

	int seek = 0;

	// HandShake
	memcpy(&(HandShakeHeader.m_HandShakeMessageType), &(body[seek]), sizeof((HandShakeHeader.m_HandShakeMessageType)));
	seek += sizeof(HandShakeHeader.m_HandShakeMessageType);
	
	// HandShakeBody
	memcpy(&(HandShakeHeader.m_body_length_high), &(body[seek]), sizeof((HandShakeHeader.m_body_length_high)));
	seek += sizeof(HandShakeHeader.m_body_length_high);
	memcpy(&(HandShakeHeader.m_body_length_mid), &(body[seek]), sizeof((HandShakeHeader.m_body_length_mid)));
	seek += sizeof(HandShakeHeader.m_body_length_mid);
	memcpy(&(HandShakeHeader.m_body_length_low), &(body[seek]), sizeof((HandShakeHeader.m_body_length_low)));
	seek += sizeof(HandShakeHeader.m_body_length_low);
	int HandShake_body_length = 0;
	HandShake_body_length += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShake_body_length += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShake_body_length += (int)(HandShakeHeader.m_body_length_low);

	int iRet = 0;
	switch(HandShakeHeader.m_HandShakeMessageType) {
	case HANDSHAKE_MES_TYPE_CL_HELLO:
		iRet = HandShakeClientHello(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	case HANDSHAKE_MES_TYPE_SV_HELLO:
		iRet = HandShakeServerHello(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	case HANDSHAKE_MES_TYPE_SV_KEY_EXCHANGE:
		iRet = HandShakeServerKeyExchange(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	case HANDSHAKE_MES_TYPE_SV_HELLO_DONE:
		iRet = HandShakeServerHelloDone(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	case HANDSHAKE_MES_TYPE_CL_KEY_EXCHANGE:
		iRet = HandShakeClientKeyExchange(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	case HANDSHAKE_MES_TYPE_FINISH:
		iRet = HandShakeFinish(HandShakeHeader, &(body[seek]));
		if(0 > iRet) { return iRet; }
		break;
	default:
		return -1;
		break;
	}
	return iRet;
}
// Mf[^iÍ؂ւj
int CAquaNetworkSession::ChangeCipherSpec(const tagDataHeader& DataHeader, unsigned const char* body)
{
	int body_length = 0;
	body_length += (int)(DataHeader.m_body_length_high * 0x010000);
	body_length += (int)(DataHeader.m_body_length_mid  * 0x000100);
	body_length += (int)(DataHeader.m_body_length_low);

	// HandShakeChangeCipherSpecDataTCYȏォǂ
	if(sizeof(tagChangeCipherSpecData) > body_length) {
		return -1;
	}

	tagChangeCipherSpecData ChangeCipherSpecData;
	memset(&ChangeCipherSpecData, 0, sizeof(tagChangeCipherSpecData));

	int seek = 0;

	// data
	memcpy(&(ChangeCipherSpecData.m_data), &(body[seek]), sizeof((ChangeCipherSpecData.m_data)));
	seek += sizeof(ChangeCipherSpecData.m_data);

	if(0x01 == ChangeCipherSpecData.m_data) {
		// Mf[^͈Í܂
		SetCryptoStateRecv(CRYPTO_STATE_CRYPTOED);
	}
	return body_length;
}
// Mf[^iÍf[^j
int CAquaNetworkSession::Cryptoed(const tagDataHeader& DataHeader, const unsigned char* body)
{
	if(NULL == body) { return -1; }
	int body_length = 0;
	body_length += (int)(DataHeader.m_body_length_high * 0x010000);
	body_length += (int)(DataHeader.m_body_length_mid  * 0x000100);
	body_length += (int)(DataHeader.m_body_length_low);
	if(0 > body_length) { return -1; }
	if(0 == body_length) { return 0; }
	size_t push_size = push_recv_buffer(body, body_length);
	return ((int)push_size);
}
/// nhVF[NbZ[W(ClientHello)𑗐M
int CAquaNetworkSession::SendHandShakeClientHello(void)
{
	// HandShakeServerHelloԐMf[^̉H
	int CryptoAlgorithmListLength = CRYPTO_ALGORITHM_LIST_MAX;

	// tagHandShakeClientHello
	tagHandShakeClientHello HandShakeClientHelloSend;
	HandShakeClientHelloSend.m_CryptoAlgorithmList_length_high = (unsigned char)(CryptoAlgorithmListLength / 0x0100);
	HandShakeClientHelloSend.m_CryptoAlgorithmList_length_low = (unsigned char)(CryptoAlgorithmListLength % 0x0100);

	int HandShakeClientHelloSendLength = 0;
	HandShakeClientHelloSendLength += sizeof(HandShakeClientHelloSend.m_CryptoAlgorithmList_length_high);
	HandShakeClientHelloSendLength += sizeof(HandShakeClientHelloSend.m_CryptoAlgorithmList_length_low);
	HandShakeClientHelloSendLength += sizeof(unsigned char) * CryptoAlgorithmListLength;

	// tagHandShakeHeader
	tagHandShakeHeader HandShakeHeaderSend;
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_CL_HELLO;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeClientHelloSendLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeClientHelloSendLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeClientHelloSendLength % 0x00010000 % 0x00000100);

	int HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeClientHelloSendLength;

	// tagDataHeader
	tagDataHeader DataHeaderSend;
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(HandShakeHeaderSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 % 0x00000100);

	int DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += HandShakeHeaderSendLength;

	// HandShakeServerHelloԐM
	char SendData[AQUA_NETWORK_SENDLEN_MAX];
	int SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	SendDataLen += sizeof(tagHandShakeHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeClientHelloSend, sizeof(tagHandShakeClientHello));
	SendDataLen += sizeof(tagHandShakeClientHello);

	eCryptoAlgorithm CryptoAlgorithm = CRYPTO_ALGORITHM_NONE;
	// ÍASYXg
	for(int i=0; i<CryptoAlgorithmListLength; i++) {
		unsigned char CryptoAlgorithm = CRYPTO_ALGORITHM_NONE + i;
		memcpy(&(SendData[SendDataLen]), &CryptoAlgorithm, sizeof(unsigned char));
		SendDataLen += sizeof(unsigned char);
	}

	// M
	int size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	return size;

}
/// nhVF[NbZ[W(ClientHello)̎M
int CAquaNetworkSession::HandShakeClientHello(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	if(sizeof(tagHandShakeClientHello) > HandShakeBodyLength) {
		return -1;
	}

	char SendData[AQUA_NETWORK_SENDLEN_MAX];
	int SendDataLen = 0;
	int size = 0;
	int total_size = 0;

	tagHandShakeClientHello HandShakeClientHello;
	memset(&HandShakeClientHello, 0, sizeof(tagHandShakeClientHello));

	int seek = 0;

	// ÍASYXg̒
	memcpy(&(HandShakeClientHello.m_CryptoAlgorithmList_length_high), &(HandShakeBody[seek]), sizeof((HandShakeClientHello.m_CryptoAlgorithmList_length_high)));
	seek += sizeof(HandShakeClientHello.m_CryptoAlgorithmList_length_high);
	memcpy(&(HandShakeClientHello.m_CryptoAlgorithmList_length_low), &(HandShakeBody[seek]), sizeof((HandShakeClientHello.m_CryptoAlgorithmList_length_low)));
	seek += sizeof(HandShakeClientHello.m_CryptoAlgorithmList_length_low);
	int CryptoAlgorithmListLength = 0;
	CryptoAlgorithmListLength += (int)(HandShakeClientHello.m_CryptoAlgorithmList_length_high  * 0x000100);
	CryptoAlgorithmListLength += (int)(HandShakeClientHello.m_CryptoAlgorithmList_length_low);

	eCryptoAlgorithm CryptoAlgorithm = CRYPTO_ALGORITHM_NONE;
	// ÍASYXg
	for(int i=0; i<CryptoAlgorithmListLength; i++) {
		// ÍASY
		unsigned char tmp;
		memcpy(&tmp, &(HandShakeBody[seek]), sizeof(unsigned char));
		seek += sizeof(unsigned char);
		CryptoAlgorithm = (eCryptoAlgorithm)tmp;
		if(CryptoAlgorithm != GetCryptoAlgorithm()) {
			continue;
		}
		break;
	}

	// HandShakeServerHelloԐMf[^̉H

	// tagHandShakeServerHello
	tagHandShakeServerHello HandShakeServerHelloSend;
	HandShakeServerHelloSend.m_CryptoAlgorithm = (unsigned char)CryptoAlgorithm;

	int HandShakeServerHelloSendLength = 0;
	HandShakeServerHelloSendLength += sizeof(HandShakeServerHelloSend.m_CryptoAlgorithm);

	// tagHandShakeHeader
	tagHandShakeHeader HandShakeHeaderSend;
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_SV_HELLO;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeServerHelloSendLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeServerHelloSendLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeServerHelloSendLength % 0x00010000 % 0x00000100);

	int HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeServerHelloSendLength;

	// tagDataHeader
	tagDataHeader DataHeaderSend;
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(HandShakeHeaderSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 % 0x00000100);

	int DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += HandShakeHeaderSendLength;

	// HandShakeServerHelloԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	SendDataLen += sizeof(tagHandShakeHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeServerHelloSend, sizeof(tagHandShakeServerHello));
	SendDataLen += sizeof(tagHandShakeServerHello);

	// M
	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;

	// HandShakeServerKeyExchangeԐMf[^̉H
	// tagHandShakeServerKeyExchange
	tagHandShakeServerKeyExchange HandShakeServerKeyExchangeSend;
	int HandShakeServerKeyExchangeLength = 0;

	// RSA擾
	int RSAPublicKeyLength = GetRSAPublicKey(HandShakeServerKeyExchangeSend.m_RSAModulus, sizeof(HandShakeServerKeyExchangeSend.m_RSAModulus));
	if(0 >= RSAPublicKeyLength) {
		return -1;
	}
	HandShakeServerKeyExchangeLength += RSAPublicKeyLength;
	unsigned long RSAPublicExponent = GetRSAPublicExponent();
	memcpy(&(HandShakeServerKeyExchangeSend.m_RSAExponent), &RSAPublicExponent, sizeof(RSAPublicExponent));
	int RSAPublicExponentLength = sizeof(RSAPublicExponent);
	HandShakeServerKeyExchangeLength += RSAPublicExponentLength;

	HandShakeServerKeyExchangeSend.m_RSAModulus_length_hight = (unsigned char)(RSAPublicKeyLength / 0x0100);
	HandShakeServerKeyExchangeLength += sizeof(HandShakeServerKeyExchangeSend.m_RSAModulus_length_hight);
	HandShakeServerKeyExchangeSend.m_RSAModulus_length_low = (unsigned char)(RSAPublicKeyLength % 0x0100);
	HandShakeServerKeyExchangeLength += sizeof(HandShakeServerKeyExchangeSend.m_RSAModulus_length_low);
	HandShakeServerKeyExchangeSend.m_RSAExponent_length_high = (unsigned char)(RSAPublicExponentLength / 0x0100);
	HandShakeServerKeyExchangeLength += sizeof(HandShakeServerKeyExchangeSend.m_RSAExponent_length_high);
	HandShakeServerKeyExchangeSend.m_RSAExponent_length_low = (unsigned char)(RSAPublicExponentLength % 0x0100);
	HandShakeServerKeyExchangeLength += sizeof(HandShakeServerKeyExchangeSend.m_RSAExponent_length_low);

	// tagHandShakeHeader
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_SV_KEY_EXCHANGE;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeServerKeyExchangeLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeServerKeyExchangeLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeServerKeyExchangeLength % 0x00010000 % 0x00000100);

	HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeServerKeyExchangeLength;

	// tagDataHeader
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(HandShakeHeaderSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 % 0x00000100);

	DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += HandShakeHeaderSendLength;

	// HandShakeServerKeyExchangԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	SendDataLen += sizeof(tagHandShakeHeader);

	memcpy(&(SendData[SendDataLen]), &(HandShakeServerKeyExchangeSend.m_RSAModulus_length_hight), sizeof(unsigned char));
	SendDataLen += sizeof(unsigned char);
	memcpy(&(SendData[SendDataLen]), &(HandShakeServerKeyExchangeSend.m_RSAModulus_length_low), sizeof(unsigned char));
	SendDataLen += sizeof(unsigned char);
	memcpy(&(SendData[SendDataLen]), HandShakeServerKeyExchangeSend.m_RSAModulus, sizeof(unsigned char) * RSAPublicKeyLength);
	SendDataLen += sizeof(unsigned char) * RSAPublicKeyLength;

	memcpy(&(SendData[SendDataLen]), &(HandShakeServerKeyExchangeSend.m_RSAExponent_length_high), sizeof(unsigned char));
	SendDataLen += sizeof(unsigned char);
	memcpy(&(SendData[SendDataLen]), &(HandShakeServerKeyExchangeSend.m_RSAExponent_length_low), sizeof(unsigned char));
	SendDataLen += sizeof(unsigned char);
	memcpy(&(SendData[SendDataLen]), HandShakeServerKeyExchangeSend.m_RSAExponent, sizeof(unsigned char) * RSAPublicExponentLength);
	SendDataLen += sizeof(unsigned char) * RSAPublicExponentLength;

	// M
	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;


	// HandShakeServerHelloDoneԐMf[^̉H
	// tagHandShakeServerHello
	tagHandShakeServerHelloDone HandShakeServerHelloDoneSend;
	int HandShakeServerHelloDoneSendLength = 0;

	// tagHandShakeHeader
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_SV_HELLO_DONE;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeServerHelloDoneSendLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeServerHelloDoneSendLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeServerHelloDoneSendLength % 0x00010000 % 0x00000100);

	HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeServerHelloDoneSendLength;

	// tagDataHeader
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(HandShakeHeaderSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 % 0x00000100);

	DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += HandShakeHeaderSendLength;

	// HandShakeServerHelloԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	SendDataLen += sizeof(tagHandShakeHeader);

//	memcpy(&(SendData[SendDataLen]), &HandShakeServerHelloDoneSend, sizeof(tagHandShakeServerHelloDone));
//	SendDataLen += sizeof(tagHandShakeServerHelloDone);

	// M
	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;

	return total_size;
}
/// nhVF[NbZ[W(ServerHello)̎M
int CAquaNetworkSession::HandShakeServerHello(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	if(sizeof(tagHandShakeServerHello) > HandShakeBodyLength) {
		return -1;
	}

	tagHandShakeServerHello HandShakeServerHello;
	memset(&HandShakeServerHello, 0, sizeof(tagHandShakeServerHello));

	int seek = 0;

	// ÍASY
	memcpy(&(HandShakeServerHello.m_CryptoAlgorithm), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	eCryptoAlgorithm CryptoAlgorithm = (eCryptoAlgorithm)HandShakeServerHello.m_CryptoAlgorithm;

	// ÍASYݒ肷
	SetCryptoAlgorithm(CryptoAlgorithm);

	return 0;
}
/// nhVF[NbZ[W(ServerKeyExchange)̎M
int CAquaNetworkSession::HandShakeServerKeyExchange(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	tagHandShakeServerKeyExchange HandShakeServerKeyExchange;
	memset(&HandShakeServerKeyExchange, 0, sizeof(tagHandShakeServerKeyExchange));

	int seek = 0;

	// RSAJ(DER`)
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeServerKeyExchange.m_RSAModulus_length_hight), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeServerKeyExchange.m_RSAModulus_length_low), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	int RSAModulusLength = (int)(HandShakeServerKeyExchange.m_RSAModulus_length_hight * 0x000100);
	RSAModulusLength += (int)(HandShakeServerKeyExchange.m_RSAModulus_length_low);
	if((seek + RSAModulusLength) > HandShakeBodyLength) { return -1; }
	memcpy(HandShakeServerKeyExchange.m_RSAModulus, &(HandShakeBody[seek]), sizeof(unsigned char) * RSAModulusLength);
	seek += RSAModulusLength;
	
	// RSAJ̌Jw
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeServerKeyExchange.m_RSAExponent_length_high), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeServerKeyExchange.m_RSAExponent_length_low), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	int RSAExponentLength = (int)(HandShakeServerKeyExchange.m_RSAExponent_length_high * 0x000100);
	RSAExponentLength += (int)(HandShakeServerKeyExchange.m_RSAExponent_length_low);
	if((seek + RSAExponentLength) > HandShakeBodyLength) { return -1; }
	memcpy(HandShakeServerKeyExchange.m_RSAExponent, &(HandShakeBody[seek]), sizeof(unsigned char) * RSAExponentLength);
	unsigned long RSAPublicExponent = 0;
	memcpy(&RSAPublicExponent, &(HandShakeServerKeyExchange.m_RSAExponent), sizeof(RSAPublicExponent));
	seek += RSAExponentLength;

	SetRSAPublicKey(HandShakeServerKeyExchange.m_RSAModulus, RSAModulusLength);
	SetRSAPublicExponent(RSAPublicExponent);

	return 0;
}
/// nhVF[NbZ[W(ServerHelloDone)̎M
int CAquaNetworkSession::HandShakeServerHelloDone(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	if(0 > HandShakeBodyLength) {
		return -1;
	}

	int size = 0;
	int total_size = 0;
	char SendData[AQUA_NETWORK_SENDLEN_MAX];
	int SendDataLen = 0;

	tagHandShakeHeader HandShakeHeaderSend;
	tagDataHeader DataHeaderSend;
	int HandShakeHeaderSendLength = 0;
	int DataHeaderSendLength = 0;

	// HandShakeClientKeyExchangeԐMf[^̉H
	// tagHandShakeClientKeyExchange
	tagHandShakeClientKeyExchange HandShakeClientKeyExchangeSend;
	int HandShakeClientKeyExchangeSendLength = 0;
	memset(&HandShakeClientKeyExchangeSend, 0, sizeof(tagHandShakeClientKeyExchange));

	// RSAJÍ擾
	unsigned char RSAPublicKey[RSA_MAX_KEY_LENGTH];
	int RSAPublicKeyLength = GetRSAPublicKey(RSAPublicKey, sizeof(RSAPublicKey));
	if(0 >= RSAPublicKeyLength) { return -1; }

	unsigned char CryptoKey[EVP_MAX_KEY_LENGTH];
	memset(CryptoKey, 0, sizeof(CryptoKey));
	int CryptoKeyLength = GetCryptoKeyLength(GetCryptoAlgorithm());
	unsigned char CryptoIV[EVP_MAX_IV_LENGTH];
	memset(CryptoIV, 0, sizeof(CryptoIV));
	int CryptoIVLength = GetCryptoIVLength(GetCryptoAlgorithm());
	
	if((0 < CryptoKeyLength) && (0 < CryptoIVLength)) {
		// ʌ̐
		select_random_key(CryptoKey, CryptoKeyLength);
		// RSAÍ
		int CryptoKeyLength_encrypt = RSA_public_encrypt_der(CryptoKeyLength, CryptoKey, HandShakeClientKeyExchangeSend.m_CryptoKey, RSAPublicKey, RSAPublicKeyLength);
		if(0 > CryptoKeyLength_encrypt) {
			return -1;
		}
		HandShakeClientKeyExchangeSendLength += CryptoKeyLength_encrypt;
		HandShakeClientKeyExchangeSend.m_CryptoKey_length_hight = (unsigned char)(CryptoKeyLength_encrypt / 0x0100);
		HandShakeClientKeyExchangeSendLength += sizeof(HandShakeClientKeyExchangeSend.m_CryptoKey_length_hight);
		HandShakeClientKeyExchangeSend.m_CryptoKey_length_low = (unsigned char)(CryptoKeyLength_encrypt % 0x0100);
		HandShakeClientKeyExchangeSendLength += sizeof(HandShakeClientKeyExchangeSend.m_CryptoKey_length_low);

		// xNg̐
		select_random_iv(CryptoIV, CryptoIVLength);
		// RSAÍ
		int CryptoIVLength_encrypt = RSA_public_encrypt_der(CryptoIVLength, CryptoIV, HandShakeClientKeyExchangeSend.m_CryptoIV, RSAPublicKey, RSAPublicKeyLength);
		if(0 > CryptoIVLength_encrypt) {
			return -1;
		}
		HandShakeClientKeyExchangeSendLength += CryptoIVLength_encrypt;
		HandShakeClientKeyExchangeSend.m_CryptoIV_length_hight = (unsigned char)(CryptoIVLength_encrypt / 0x0100);
		HandShakeClientKeyExchangeSendLength += sizeof(HandShakeClientKeyExchangeSend.m_CryptoIV_length_hight);
		HandShakeClientKeyExchangeSend.m_CryptoIV_length_low = (unsigned char)(CryptoIVLength_encrypt % 0x0100);
		HandShakeClientKeyExchangeSendLength += sizeof(HandShakeClientKeyExchangeSend.m_CryptoIV_length_low);

		// tagHandShakeHeader
		HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_CL_KEY_EXCHANGE;
		HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeClientKeyExchangeSendLength / 0x00010000);
		HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeClientKeyExchangeSendLength % 0x00010000 / 0x00000100);
		HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeClientKeyExchangeSendLength % 0x00010000 % 0x00000100);

		HandShakeHeaderSendLength = 0;
		HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
		HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
		HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
		HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
		HandShakeHeaderSendLength += HandShakeClientKeyExchangeSendLength;

		// tagDataHeader
		DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
		DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
		DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
		DataHeaderSend.m_body_length_high = (unsigned char)(HandShakeHeaderSendLength / 0x00010000);
		DataHeaderSend.m_body_length_mid = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 / 0x00000100);
		DataHeaderSend.m_body_length_low = (unsigned char)(HandShakeHeaderSendLength % 0x00010000 % 0x00000100);

		DataHeaderSendLength = 0;
		DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
		DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
		DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
		DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
		DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
		DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
		DataHeaderSendLength += HandShakeHeaderSendLength;

		// HandShakeClientKeyExchangeԐM
		SendDataLen = 0;
		memset(SendData, 0, sizeof(SendData));

		memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
		SendDataLen += sizeof(tagDataHeader);
		memcpy(&(SendData[SendDataLen]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
		SendDataLen += sizeof(tagHandShakeHeader);
		memcpy(&(SendData[SendDataLen]), &(HandShakeClientKeyExchangeSend.m_CryptoKey_length_hight), sizeof(unsigned char));
		SendDataLen += sizeof(unsigned char);
		memcpy(&(SendData[SendDataLen]), &(HandShakeClientKeyExchangeSend.m_CryptoKey_length_low), sizeof(unsigned char));
		SendDataLen += sizeof(unsigned char);
		memcpy(&(SendData[SendDataLen]), HandShakeClientKeyExchangeSend.m_CryptoKey, sizeof(unsigned char) * CryptoKeyLength_encrypt);
		SendDataLen += sizeof(unsigned char) * CryptoKeyLength_encrypt;
		memcpy(&(SendData[SendDataLen]), &(HandShakeClientKeyExchangeSend.m_CryptoIV_length_hight), sizeof(unsigned char));
		SendDataLen += sizeof(unsigned char);
		memcpy(&(SendData[SendDataLen]), &(HandShakeClientKeyExchangeSend.m_CryptoIV_length_low), sizeof(unsigned char));
		SendDataLen += sizeof(unsigned char);
		memcpy(&(SendData[SendDataLen]), HandShakeClientKeyExchangeSend.m_CryptoIV, sizeof(unsigned char) * CryptoIVLength_encrypt);
		SendDataLen += sizeof(unsigned char) * CryptoIVLength_encrypt;

		// M
		size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
		if(0 > size) { return size; }

		// ʌ𕡐
		SetCryptoKey(CryptoKey, CryptoKeyLength);
		SetCryptoIV(CryptoIV, CryptoIVLength);

		total_size += size;
	}

	// ChangeCipherSpecԐMf[^̉H

	// tagChangeCipherSpecData
	tagChangeCipherSpecData ChangeCipherSpecDataSend;
	ChangeCipherSpecDataSend.m_data = 0x01;

	int ChangeCipherSpecDataSendLength = 0;
	ChangeCipherSpecDataSendLength += sizeof(ChangeCipherSpecDataSend.m_data);

	// tagDataHeader
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_CHANGE_CIPHER_SPEC;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(ChangeCipherSpecDataSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(ChangeCipherSpecDataSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(ChangeCipherSpecDataSendLength % 0x00010000 % 0x00000100);

	DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += DataHeaderSendLength;

	// ChangeCipherSpecԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &ChangeCipherSpecDataSend, sizeof(tagChangeCipherSpecData));
	SendDataLen += sizeof(tagChangeCipherSpecData);

	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;
	
	// 摗Mf[^͈Í܂
	SetCryptoStateSend(CRYPTO_STATE_CRYPTOED);

	// HandShakeFinishԐMf[^̉H

	// tagHandShakeFinish
	tagHandShakeFinish HandShakeFinishSend;
	int HandShakeFinishSendLength = 0;

	// tagHandShakeHeader
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_FINISH;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeFinishSendLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeFinishSendLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeFinishSendLength % 0x00010000 % 0x00000100);

	HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeFinishSendLength;

	char plain_body[AQUA_NETWORK_RECVLEN_MAX];
	memset(plain_body, 0, sizeof(plain_body));
	int plain_body_length = 0;
	memcpy(&(plain_body[plain_body_length]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	plain_body_length += sizeof(tagHandShakeHeader);

	char body[AQUA_NETWORK_RECVLEN_MAX];
	memset(body, 0, sizeof(body));
	int body_length = 0;

	int encrypt_length = 0;
	switch(GetCryptoAlgorithm()) {
	case CRYPTO_ALGORITHM_NONE:
		memcpy(&(body[body_length]), plain_body, sizeof(unsigned char) * plain_body_length);
		body_length += plain_body_length;
		break;
	case CRYPTO_ALGORITHM_3DES:
		{
		// Í̗LmF
		encrypt_length = encrypt_DES_EDE3((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
		if(0 > encrypt_length) { return -1; } 
		body_length += encrypt_length;
		break;
		}
	case CRYPTO_ALGORITHM_BLOWFISH:
		{
		// Í̗LmF
		encrypt_length = encrypt_BF((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
		if(0 > encrypt_length) { return -1; } 
		body_length += encrypt_length;

		break;
		}
	}

	// tagDataHeader
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(body_length / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(body_length % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(body_length % 0x00010000 % 0x00000100);

	DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += body_length;

	// HandShakeFinishԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), body, sizeof(unsigned char) * body_length);
	SendDataLen += sizeof(unsigned char) * body_length;

	// M
	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;

	return total_size;
}
/// nhVF[NbZ[W(ClientKeyExchange)̎M
int CAquaNetworkSession::HandShakeClientKeyExchange(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	tagHandShakeClientKeyExchange HandShakeClientKeyExchange;
	memset(&HandShakeClientKeyExchange, 0, sizeof(tagHandShakeClientKeyExchange));

	int seek = 0;

	// RSA閧Í擾
	unsigned char RSAPrivateKey[RSA_MAX_KEY_LENGTH];
	int RSAPrivateKeyLength = GetRSAPrivateKey(RSAPrivateKey, sizeof(RSAPrivateKey));
	if(0 >= RSAPrivateKeyLength) { return -1; }

	// ʌ
	unsigned char CryptoKey[EVP_MAX_KEY_LENGTH*10];
	memset(CryptoKey, 0, sizeof(CryptoKey));
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeClientKeyExchange.m_CryptoKey_length_hight), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeClientKeyExchange.m_CryptoKey_length_low), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	int CryptoKeyLength = (int)(HandShakeClientKeyExchange.m_CryptoKey_length_hight * 0x000100);
	CryptoKeyLength += (int)(HandShakeClientKeyExchange.m_CryptoKey_length_low);
	if((seek + CryptoKeyLength) > HandShakeBodyLength) { return -1; }
	memcpy(HandShakeClientKeyExchange.m_CryptoKey, &(HandShakeBody[seek]), sizeof(unsigned char) * CryptoKeyLength);
	seek += CryptoKeyLength;
	// RSA
	int CryptoKeyLength_decrypt = RSA_private_decrypt_der(CryptoKeyLength, HandShakeClientKeyExchange.m_CryptoKey, CryptoKey, RSAPrivateKey, RSAPrivateKeyLength);
	if(0 > CryptoKeyLength_decrypt) {
		return -1;
	}

	// xNg
	unsigned char CryptoIV[EVP_MAX_IV_LENGTH*10];
	memset(CryptoIV, 0, sizeof(CryptoIV));
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeClientKeyExchange.m_CryptoIV_length_hight), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	if((seek + (int)sizeof(unsigned char)) > HandShakeBodyLength) { return -1; }
	memcpy(&(HandShakeClientKeyExchange.m_CryptoIV_length_low), &(HandShakeBody[seek]), sizeof(unsigned char));
	seek += sizeof(unsigned char);
	int CryptoIVLength = (int)(HandShakeClientKeyExchange.m_CryptoIV_length_hight * 0x000100);
	CryptoIVLength += (int)(HandShakeClientKeyExchange.m_CryptoIV_length_low);
	if((seek + CryptoIVLength) > HandShakeBodyLength) { return -1; }
	memcpy(HandShakeClientKeyExchange.m_CryptoIV, &(HandShakeBody[seek]), sizeof(unsigned char) * CryptoIVLength);
	seek += CryptoIVLength;
	// RSA
	int CryptoIVLength_decrypt = RSA_private_decrypt_der(CryptoIVLength, HandShakeClientKeyExchange.m_CryptoIV, CryptoIV, RSAPrivateKey, RSAPrivateKeyLength);
	if(0 > CryptoIVLength_decrypt) {
		return -1;
	}

	// ʌ𕡐
	SetCryptoKey(CryptoKey, CryptoKeyLength_decrypt);
	SetCryptoIV(CryptoIV, CryptoIVLength_decrypt);

	return 0;
}
/// nhVF[NbZ[W(Finish)̎M
int CAquaNetworkSession::HandShakeFinish(const tagHandShakeHeader& HandShakeHeader, const unsigned char* HandShakeBody)
{
	int HandShakeBodyLength = 0;
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_high * 0x010000);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_mid  * 0x000100);
	HandShakeBodyLength += (int)(HandShakeHeader.m_body_length_low);

	if(0 > HandShakeBodyLength) {
		return -1;
	}

	if(CRYPTO_STATE_CRYPTOED == GetCryptoStateSend()) {
		// ɑ葤̓nhVF[Nς݂Ȃ̂ChangeCipherSpecHandShakeFinish͑M܂

		// nhVF[Nʒm	
		call_cbfunc_Event(SESSION_EVENT_TYPE_HANDSHAKE_FINISH);
		return 0;
	}

	char SendData[AQUA_NETWORK_SENDLEN_MAX];
	int SendDataLen = 0;
	int size = 0;
	int total_size = 0;

	// ChangeCipherSpecԐMf[^̉H

	// tagChangeCipherSpecData
	tagChangeCipherSpecData ChangeCipherSpecDataSend;
	ChangeCipherSpecDataSend.m_data = 0x01;

	int ChangeCipherSpecDataSendLength = 0;
	ChangeCipherSpecDataSendLength += sizeof(ChangeCipherSpecDataSend.m_data);

	// tagDataHeader
	tagDataHeader DataHeaderSend;
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_CHANGE_CIPHER_SPEC;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(ChangeCipherSpecDataSendLength / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(ChangeCipherSpecDataSendLength % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(ChangeCipherSpecDataSendLength % 0x00010000 % 0x00000100);

	int DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += DataHeaderSendLength;

	// ChangeCipherSpecԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), &ChangeCipherSpecDataSend, sizeof(tagChangeCipherSpecData));
	SendDataLen += sizeof(tagChangeCipherSpecData);

	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;

	// 摗Mf[^͈Í܂
	SetCryptoStateSend(CRYPTO_STATE_CRYPTOED);

	// HandShakeFinishԐMf[^̉H

	// tagHandShakeFinish
	tagHandShakeFinish HandShakeFinishSend;
	int HandShakeFinishSendLength = 0;

	// tagHandShakeHeader
	tagHandShakeHeader HandShakeHeaderSend;
	HandShakeHeaderSend.m_HandShakeMessageType = HANDSHAKE_MES_TYPE_FINISH;
	HandShakeHeaderSend.m_body_length_high = (unsigned char)(HandShakeFinishSendLength / 0x00010000);
	HandShakeHeaderSend.m_body_length_mid = (unsigned char)(HandShakeFinishSendLength % 0x00010000 / 0x00000100);
	HandShakeHeaderSend.m_body_length_low = (unsigned char)(HandShakeFinishSendLength % 0x00010000 % 0x00000100);

	int HandShakeHeaderSendLength = 0;
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_HandShakeMessageType);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_high);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += sizeof(HandShakeHeaderSend.m_body_length_mid);
	HandShakeHeaderSendLength += HandShakeFinishSendLength;

	char plain_body[AQUA_NETWORK_RECVLEN_MAX];
	memset(plain_body, 0, sizeof(plain_body));
	int plain_body_length = 0;
	memcpy(&(plain_body[plain_body_length]), &HandShakeHeaderSend, sizeof(tagHandShakeHeader));
	plain_body_length += sizeof(tagHandShakeHeader);

	char body[AQUA_NETWORK_RECVLEN_MAX];
	memset(body, 0, sizeof(body));
	int body_length = 0;

	// ʌ擾
	unsigned char CryptoKey[EVP_MAX_KEY_LENGTH];
	int CryptoKeyLength = GetCryptoKey(CryptoKey, sizeof(CryptoKey));
	if(0 > CryptoKeyLength) { return -1; }
	// xNg擾
	unsigned char CryptoIV[EVP_MAX_IV_LENGTH];
	int CryptoIVLength = GetCryptoIV(CryptoIV, sizeof(CryptoIV));
	if(0 > CryptoIVLength) { return -1; }

	int encrypt_length = 0;
	switch(GetCryptoAlgorithm()) {
	case CRYPTO_ALGORITHM_NONE:
		memcpy(&(body[body_length]), plain_body, sizeof(unsigned char) * plain_body_length);
		body_length += plain_body_length;
		break;
	case CRYPTO_ALGORITHM_3DES:
		// Í̗LmF
		encrypt_length = encrypt_DES_EDE3((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
		if(0 > encrypt_length) { return -1; } 
		body_length += encrypt_length;
		break;
	case CRYPTO_ALGORITHM_BLOWFISH:
		// Í̗LmF
		encrypt_length = encrypt_BF((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
		if(0 > encrypt_length) { return -1; } 
		body_length += encrypt_length;
		break;
	}

	// tagDataHeader
	DataHeaderSend.m_CryptoMessageType = CRYPTO_MES_TYPE_HANDSHAKE;
	DataHeaderSend.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeaderSend.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;
	DataHeaderSend.m_body_length_high = (unsigned char)(body_length / 0x00010000);
	DataHeaderSend.m_body_length_mid = (unsigned char)(body_length % 0x00010000 / 0x00000100);
	DataHeaderSend.m_body_length_low = (unsigned char)(body_length % 0x00010000 % 0x00000100);

	DataHeaderSendLength = 0;
	DataHeaderSendLength += sizeof(DataHeaderSend.m_CryptoMessageType);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MajorProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_MinerProtocolVersion);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_high);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_mid);
	DataHeaderSendLength += sizeof(DataHeaderSend.m_body_length_low);
	DataHeaderSendLength += body_length;

	// HandShakeFinishԐM
	SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	memcpy(&(SendData[SendDataLen]), &DataHeaderSend, sizeof(tagDataHeader));
	SendDataLen += sizeof(tagDataHeader);

	memcpy(&(SendData[SendDataLen]), body, sizeof(unsigned char) * body_length);
	SendDataLen += sizeof(unsigned char) * body_length;

	// M
	size = ::send(m_ConnectSocket, SendData, SendDataLen, 0);
	if(0 > size) { return size; }
	total_size += size;

	// nhVF[Nʒm	
	call_cbfunc_Event(SESSION_EVENT_TYPE_HANDSHAKE_FINISH);
	return total_size;
}
/// MR[obN֐̌Ăяo
int CAquaNetworkSession::call_cbfunc_Event(short ev)
{
	int iRet = 1;
	if(NULL != m_cbfunc_Event) {
		iRet = m_cbfunc_Event(this, ev, m_cbfunc_EventParam);
	}
	return iRet;
}
/// ŏIrecv֐ōsCryptoMessage擾
CryptoMessages CAquaNetworkSession::GetLastRecvCryptoMessages(void) const
{
	return m_LastRecvCryptoMessages;
}
int CAquaNetworkSession::send(const unsigned char* buf, int num, int flags)
{
//	int size = ::send(m_ConnectSocket, buf, num, flags);
//	return size;

	tagDataHeader DataHeader;
	memset(&DataHeader, 0, sizeof(tagDataHeader));
	if(CRYPTO_ALGORITHM_NONE == GetCryptoAlgorithm()) {
		DataHeader.m_CryptoMessageType = (unsigned char)CRYPTO_MES_TYPE_PLAIN;
	} else {
		DataHeader.m_CryptoMessageType = (unsigned char)CRYPTO_MES_TYPE_CRYPTOED;
	}
	DataHeader.m_MajorProtocolVersion = MAJOR_PROTOCOL_VERSION;
	DataHeader.m_MinerProtocolVersion = MINER_PROTOCOL_VERSION;

	char SendData[AQUA_NETWORK_SENDLEN_MAX];
	int SendDataLen = 0;
	memset(SendData, 0, sizeof(SendData));

	// f[^
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_CryptoMessageType), sizeof(DataHeader.m_CryptoMessageType));
	SendDataLen += sizeof(DataHeader.m_CryptoMessageType);

	/// vgRo[W
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_MajorProtocolVersion), sizeof(DataHeader.m_MajorProtocolVersion));
	SendDataLen += sizeof(DataHeader.m_MajorProtocolVersion);
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_MinerProtocolVersion), sizeof(DataHeader.m_MinerProtocolVersion));
	SendDataLen += sizeof(DataHeader.m_MinerProtocolVersion);

	char plain_body[AQUA_NETWORK_RECVLEN_MAX];
	memset(plain_body, 0, sizeof(plain_body));
	int plain_body_length = 0;
	memcpy(&(plain_body[plain_body_length]), buf, sizeof(unsigned char) * num);
	plain_body_length += sizeof(unsigned char) * num;

	char body[AQUA_NETWORK_RECVLEN_MAX];
	memset(body, 0, sizeof(body));
	int body_length = 0;
	int encrypt_length = 0;

	if(CRYPTO_STATE_PLAIN == GetCryptoStateSend()) {
		memcpy(&(body[body_length]), plain_body, sizeof(unsigned char) * plain_body_length);
		body_length += plain_body_length;
	} else {
		// ʌ擾
		unsigned char CryptoKey[EVP_MAX_KEY_LENGTH];
		int CryptoKeyLength = GetCryptoKey(CryptoKey, sizeof(CryptoKey));
		if(0 > CryptoKeyLength) { return -1; }
		// xNg擾
		unsigned char CryptoIV[EVP_MAX_IV_LENGTH];
		int CryptoIVLength = GetCryptoIV(CryptoIV, sizeof(CryptoIV));
		if(0 > CryptoIVLength) { return -1; }

		switch(GetCryptoAlgorithm()) {
		case CRYPTO_ALGORITHM_NONE:
			memcpy(&(body[body_length]), plain_body, sizeof(unsigned char) * plain_body_length);
			body_length += plain_body_length;
			break;
		case CRYPTO_ALGORITHM_3DES:
			encrypt_length = encrypt_DES_EDE3((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
			if(0 > encrypt_length) { return -1; } 
			body_length += encrypt_length;
			break;
		case CRYPTO_ALGORITHM_BLOWFISH:
			encrypt_length = encrypt_BF((unsigned char*)&(body[body_length]), sizeof(body) - body_length, (const unsigned char*)plain_body, sizeof(unsigned char) * plain_body_length, CryptoKey, CryptoKeyLength, CryptoIV, CryptoIVLength);
			if(0 > encrypt_length) { return -1; } 
			body_length += encrypt_length;
			break;
		}
	}

	// f[^
	DataHeader.m_body_length_high = (unsigned char)(body_length / 0x00010000);
	DataHeader.m_body_length_mid = (unsigned char)(body_length % 0xff00 / 0x00000100);
	DataHeader.m_body_length_low = (unsigned char)(body_length % 0xff00 % 0x00000100);
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_body_length_high), sizeof(DataHeader.m_body_length_high));
	SendDataLen += sizeof(DataHeader.m_body_length_high);
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_body_length_mid), sizeof(DataHeader.m_body_length_mid));
	SendDataLen += sizeof(DataHeader.m_body_length_mid);
	memcpy(&(SendData[SendDataLen]), &(DataHeader.m_body_length_low), sizeof(DataHeader.m_body_length_low));
	SendDataLen += sizeof(DataHeader.m_body_length_low);

	// f[^{
	memcpy(&(SendData[SendDataLen]), body, sizeof(unsigned char) * body_length);
	SendDataLen += sizeof(unsigned char) * body_length;

	// M
	int size = ::send(m_ConnectSocket, SendData, SendDataLen, flags);
	if(0 > size) { return size; }
	size -= sizeof(tagDataHeader);
	return size;
}
/// ÍASY擾
eCryptoAlgorithm CAquaNetworkSession::GetCryptoAlgorithm(void) const
{
	return m_CryptoAlgorithm;
}
/// ÍASYݒ肷
void CAquaNetworkSession::SetCryptoAlgorithm(eCryptoAlgorithm CryptoAlgorithm)
{
	m_CryptoAlgorithm = CryptoAlgorithm;
}
/// ÍԂ擾(Recv)
eCryptoState CAquaNetworkSession::GetCryptoStateRecv(void) const
{
	return m_CryptoStateRecv;
}
/// ÍԂݒ肷(Recv)
void CAquaNetworkSession::SetCryptoStateRecv(eCryptoState CryptoState)
{
	m_CryptoStateRecv = CryptoState;
}
/// ÍԂ擾(Send)
eCryptoState CAquaNetworkSession::GetCryptoStateSend(void) const
{
	return m_CryptoStateSend;
}
/// ÍԂݒ肷(Send)
void CAquaNetworkSession::SetCryptoStateSend(eCryptoState CryptoState)
{
	m_CryptoStateSend = CryptoState;
}
/// ʐMpÍ擾
int CAquaNetworkSession::GetCryptoKey(unsigned char* CryptoKey, int CryptoKeyLength) const
{
	if(NULL == CryptoKey) { return -1; }
	if(0 >= CryptoKeyLength) { return -1; }
	if(m_CryptoKeyLength > CryptoKeyLength) { return -1; }

	// i[
	memset(CryptoKey, 0, sizeof(unsigned char) * CryptoKeyLength);
	// i[֕
	memcpy(CryptoKey, m_CryptoKey, sizeof(unsigned char) * m_CryptoKeyLength);

	return m_CryptoKeyLength;
}
/// ʐMpÍݒ
int CAquaNetworkSession::SetCryptoKey(const unsigned char* CryptoKey, int CryptoKeyLength)
{
	if(NULL == CryptoKey) { return -1; }
	if(0 >= CryptoKeyLength) { return -1; }
	if((int)sizeof(m_CryptoKey) < CryptoKeyLength) { return -1; }

	// i[
	memset(m_CryptoKey, 0, sizeof(m_CryptoKey));
	// i[֕
	memcpy(m_CryptoKey, CryptoKey, sizeof(unsigned char) * CryptoKeyLength);
	m_CryptoKeyLength = CryptoKeyLength;

	return CryptoKeyLength;
}
/// ʐMpÍxNg擾
int CAquaNetworkSession::GetCryptoIV(unsigned char* CryptoIV, int CryptoIVLength) const
{
	if(NULL == CryptoIV) { return -1; }
	if(0 >= CryptoIVLength) { return -1; }
	if(m_CryptoIVLength > CryptoIVLength) { return -1; }

	// i[
	memset(CryptoIV, 0, sizeof(unsigned char) * CryptoIVLength);
	// i[֕
	memcpy(CryptoIV, m_CryptoIV, sizeof(unsigned char) * m_CryptoIVLength);

	return m_CryptoIVLength;
}
/// ʐMpÍxNgݒ
int CAquaNetworkSession::SetCryptoIV(const unsigned char* CryptoIV, int CryptoIVLength)
{
	if(NULL == CryptoIV) { return -1; }
	if(0 >= CryptoIVLength) { return -1; }
	if((int)sizeof(m_CryptoIV) < CryptoIVLength) { return -1; }

	// i[
	memset(m_CryptoIV, 0, sizeof(m_CryptoIV));
	// i[֕
	memcpy(m_CryptoIV, CryptoIV, sizeof(unsigned char) * CryptoIVLength);
	m_CryptoIVLength = CryptoIVLength;

	return CryptoIVLength;
}
/// ʐM閧ÍpRSA閧擾
int CAquaNetworkSession::GetRSAPrivateKey(unsigned char* RSAPrivateKey, int RSAPrivateKeyLength) const
{
	if(NULL == RSAPrivateKey) { return -1; }
	if(0 >= RSAPrivateKeyLength) { return -1; }
	if(m_RSAPrivateKeyLength > RSAPrivateKeyLength) { return -1; }

	// i[
	memset(RSAPrivateKey, 0, sizeof(unsigned char) * RSAPrivateKeyLength);
	// i[֕
	memcpy(RSAPrivateKey, m_RSAPrivateKey, sizeof(unsigned char) * m_RSAPrivateKeyLength);

	return m_RSAPrivateKeyLength;
}
/// ʐM閧ÍpRSA閧ݒ
int CAquaNetworkSession::SetRSAPrivateKey(const unsigned char* RSAPrivateKey, int RSAPrivateKeyLength)
{
	if(NULL == RSAPrivateKey) { return -1; }
	if(0 >= RSAPrivateKeyLength) { return -1; }
	if((int)sizeof(m_RSAPrivateKey) < RSAPrivateKeyLength) { return -1; }

	// i[
	memset(m_RSAPrivateKey, 0, sizeof(m_RSAPrivateKey));
	// i[֕
	memcpy(m_RSAPrivateKey, RSAPrivateKey, sizeof(unsigned char) * RSAPrivateKeyLength);
	m_RSAPrivateKeyLength = RSAPrivateKeyLength;

	return RSAPrivateKeyLength;
}
/// ʐM閧ÍpRSAJ擾
int CAquaNetworkSession::GetRSAPublicKey(unsigned char* RSAPublicKey, int RSAPublicKeyLength) const
{
	if(NULL == RSAPublicKey) { return -1; }
	if(0 >= RSAPublicKeyLength) { return -1; }
	if(m_RSAPublicKeyLength > RSAPublicKeyLength) { return -1; }

	// i[
	memset(RSAPublicKey, 0, sizeof(unsigned char) * RSAPublicKeyLength);
	// i[֕
	memcpy(RSAPublicKey, m_RSAPublicKey, sizeof(unsigned char) * m_RSAPublicKeyLength);

	return m_RSAPublicKeyLength;
}
/// ʐM閧ÍpRSAJݒ
int CAquaNetworkSession::SetRSAPublicKey(const unsigned char* RSAPublicKey, int RSAPublicKeyLength)
{
	if(NULL == RSAPublicKey) { return -1; }
	if(0 >= RSAPublicKeyLength) { return -1; }
	if((int)sizeof(m_RSAPublicKey) < RSAPublicKeyLength) { return -1; }

	// i[
	memset(m_RSAPublicKey, 0, sizeof(m_RSAPublicKey));
	// i[֕
	memcpy(m_RSAPublicKey, RSAPublicKey, sizeof(unsigned char) * RSAPublicKeyLength);
	m_RSAPublicKeyLength = RSAPublicKeyLength;

	return RSAPublicKeyLength;
}
/// ʐM閧ÍpRSAJ̈Íw擾
unsigned long CAquaNetworkSession::GetRSAPublicExponent(void) const
{
	return m_RSAPublicExponent;
}
/// ʐM閧ÍpRSAJ̈Íwݒ
void CAquaNetworkSession::SetRSAPublicExponent(unsigned long RSAPublicExponent)
{
	m_RSAPublicExponent = RSAPublicExponent;
}


#ifdef USEING_WINSOCK_SELECT
/// WinSockSelect
int CAquaNetworkSession::WSAAsyncSelect(HWND hWnd, u_int wMsg, long lEvent)
{
	return (::WSAAsyncSelect(m_ConnectSocket, hWnd, wMsg, lEvent));
}
#endif // USEING_WINSOCK_SELECT
/// gIuWFNg֘At
void CAquaNetworkSession::attach_ExtensionObject(void* object)
{
	m_ExtensionObject = object;
}
/// gIuWFNg֘At
void CAquaNetworkSession::detach_ExtensionObject(void)
{
	m_ExtensionObject = NULL;
}
/// gIuWFNg擾
void* CAquaNetworkSession::get_ExtensionObject(void)
{
	return m_ExtensionObject;
}
/// gIuWFNg擾(const)
const void* CAquaNetworkSession::get_ExtensionObject(void) const
{
	return m_ExtensionObject;
}

//==============================================
// class CAquaNetworkSessionListen
//==============================================
CAquaNetworkSessionListen::CAquaNetworkSessionListen()
{
	m_bUsed = false;
	m_ListenSocket = -1;
#ifdef USEING_LIBEVENT
	m_bListenLibEventFlag = false;
#endif // USEING_LIBEVENT

	memset(m_ListenService, 0, sizeof(m_ListenService));
	m_cbfunc_Event = NULL;
	m_cbfunc_EventParam = NULL;

	memset(m_RSAPrivateKey, 0, sizeof(m_RSAPrivateKey));
	m_RSAPrivateKeyLength = 0;
	memset(m_RSAPublicKey, 0, sizeof(m_RSAPublicKey));
	m_RSAPublicKeyLength = 0;
	m_RSAPublicExponent = 0;
}
CAquaNetworkSessionListen::~CAquaNetworkSessionListen()
{
	SetUsed(false);
}
/// gptO擾
bool CAquaNetworkSessionListen::IsUsed() const
{
	return m_bUsed;
}
/// gptOݒ
void CAquaNetworkSessionListen::SetUsed(bool bFlag)
{
	m_bUsed = bFlag;
	if(!m_bUsed) {
		Close();
	}
}
/// MR[obN֐|C^擾
ty_cbfunc_Event CAquaNetworkSessionListen::Get_cbfunc_Event(void)
{
	return m_cbfunc_Event;
}
/// ListenT[rX擾
const char* CAquaNetworkSessionListen::GetListenService(void) const
{
	return m_ListenService;
}
/// ListenT[rXݒ肷
void CAquaNetworkSessionListen::SetListenService(const char* service)
{
	if(NULL == service) { return; }
	strncpy(m_ListenService, service, sizeof(m_ListenService));
}
/// MR[obN֐|C^擾(const)
const ty_cbfunc_Event CAquaNetworkSessionListen::Get_cbfunc_Event(void) const
{
	return m_cbfunc_Event;
}
/// MR[obN֐̈|C^擾
void* CAquaNetworkSessionListen::Get_cbfunc_EventParam(void)
{
	return m_cbfunc_EventParam;
}
/// MR[obN֐̈|C^擾(const)
const void* CAquaNetworkSessionListen::Get_cbfunc_EventParam(void) const
{
	return m_cbfunc_EventParam;
}
/// listenp\Pbg擾
SOCKET CAquaNetworkSessionListen::GetSocket(void)
{
	return m_ListenSocket;
}
/// listenp\Pbg擾(const)
SOCKET CAquaNetworkSessionListen::GetSocket(void) const
{
	return m_ListenSocket;
}
/// ʐMÍASYʂ擾
eCryptoAlgorithm CAquaNetworkSessionListen::GetCryptoAlgorithm(void) const
{
	return m_CryptoAlgorithm;
}
/// ʐM閧ÍpRSA閧
int CAquaNetworkSessionListen::GenerateRSAKey(int bits, unsigned long e)
{
	m_RSAPublicExponent = e;
	return RSA_generate_key_der(bits, m_RSAPublicExponent, m_RSAPrivateKey, &m_RSAPrivateKeyLength, m_RSAPublicKey, &m_RSAPublicKeyLength);
}
/// ʐM閧ÍpRSA閧擾
int CAquaNetworkSessionListen::GetRSAPrivateKey(unsigned char* RSAPrivateKey, int RSAPrivateKeyLength) const
{
	if(NULL == RSAPrivateKey) { return -1; }
	if(0 >= RSAPrivateKeyLength) { return -1; }
	if(m_RSAPrivateKeyLength > RSAPrivateKeyLength) { return -1; }

	// i[
	memset(RSAPrivateKey, 0, sizeof(unsigned char) * RSAPrivateKeyLength);
	// i[֕
	memcpy(RSAPrivateKey, m_RSAPrivateKey, sizeof(unsigned char) * m_RSAPrivateKeyLength);

	return m_RSAPrivateKeyLength;
}
/// ʐM閧ÍpRSA閧ݒ
int CAquaNetworkSessionListen::SetRSAPrivateKey(const unsigned char* RSAPrivateKey, int RSAPrivateKeyLength)
{
	if(NULL == RSAPrivateKey) { return -1; }
	if(0 >= RSAPrivateKeyLength) { return -1; }
	if((int)sizeof(m_RSAPrivateKey) < RSAPrivateKeyLength) { return -1; }

	// i[
	memset(m_RSAPrivateKey, 0, sizeof(m_RSAPrivateKey));
	// i[֕
	memcpy(m_RSAPrivateKey, RSAPrivateKey, sizeof(unsigned char) * RSAPrivateKeyLength);
	m_RSAPrivateKeyLength = RSAPrivateKeyLength;

	return RSAPrivateKeyLength;
}
/// ʐM閧ÍpRSAJ擾
int CAquaNetworkSessionListen::GetRSAPublicKey(unsigned char* RSAPublicKey, int RSAPublicKeyLength) const
{
	if(NULL == RSAPublicKey) { return -1; }
	if(0 >= RSAPublicKeyLength) { return -1; }
	if(m_RSAPublicKeyLength > RSAPublicKeyLength) { return -1; }

	// i[
	memset(RSAPublicKey, 0, sizeof(unsigned char) * RSAPublicKeyLength);
	// i[֕
	memcpy(RSAPublicKey, m_RSAPublicKey, sizeof(unsigned char) * m_RSAPublicKeyLength);

	return m_RSAPublicKeyLength;
}
/// ʐM閧ÍpRSAJݒ
int CAquaNetworkSessionListen::SetRSAPublicKey(const unsigned char* RSAPublicKey, int RSAPublicKeyLength)
{
	if(NULL == RSAPublicKey) { return -1; }
	if(0 >= RSAPublicKeyLength) { return -1; }
	if((int)sizeof(m_RSAPublicKey) < RSAPublicKeyLength) { return -1; }

	// i[
	memset(m_RSAPublicKey, 0, sizeof(m_RSAPublicKey));
	// i[֕
	memcpy(m_RSAPublicKey, RSAPublicKey, sizeof(unsigned char) * RSAPublicKeyLength);
	m_RSAPublicKeyLength = RSAPublicKeyLength;

	return RSAPublicKeyLength;
}
/// ʐM閧ÍpRSAJ̈Íw擾
unsigned long CAquaNetworkSessionListen::GetRSAPublicExponent(void) const
{
	return m_RSAPublicExponent;
}
/// ʐM閧ÍpRSAJ̈Íwݒ
void CAquaNetworkSessionListen::SetRSAPublicExponent(unsigned long RSAPublicExponent)
{
	m_RSAPublicExponent = RSAPublicExponent;
}
#ifdef USEING_LIBEVENT
/// listenpҋ@CxgpIuWFNgݒ
void CAquaNetworkSessionListen::SetLibEvent(short libevent, void(*fn)(int, short, void *), void* arg)
{
	return event_set(&m_ListenLibEvent, m_ListenSocket, libevent, fn, arg);
}
/// listenpҋ@CxgpIuWFNgǉ
int CAquaNetworkSessionListen::AddLibEvent(struct timeval* tv)
{
	m_bListenLibEventFlag = true;
	return event_add(&m_ListenLibEvent, tv);
}
/// listenpҋ@CxgpIuWFNg폜
int CAquaNetworkSessionListen::DelLibEvent(void)
{
	if(m_bListenLibEventFlag) {
		m_bListenLibEventFlag = false;
		return event_del(&m_ListenLibEvent);
	}
	return -1;
}
#endif // USEING_LIBEVENT
/// \Pbgڑ󂯂
SOCKET CAquaNetworkSessionListen::Accept(struct sockaddr *addr, socklen_t *addrlen)
{
	return(::accept(m_ListenSocket, (struct sockaddr *) addr, addrlen));
}
/// \Pbgڑ̑ҋ@I
void CAquaNetworkSessionListen::Close(void)
{
	if(0 < m_ListenSocket) {
#ifdef USEING_LIBEVENT
		this->DelLibEvent();
#endif // USEING_LIBEVENT
		closesocket(this->m_ListenSocket);
		this->m_ListenSocket = -1;
		this->m_CryptoAlgorithm = CRYPTO_ALGORITHM_NONE;
		memset(this->m_RSAPrivateKey, 0, sizeof(this->m_RSAPrivateKey));
		this->m_RSAPrivateKeyLength = 0;
		memset(this->m_RSAPublicKey, 0, sizeof(this->m_RSAPublicKey));
		this->m_RSAPublicKeyLength = 0;
		this->m_RSAPublicExponent = 0;
	}
}
/// \Pbgڑ̑ҋ@Jn
SOCKET CAquaNetworkSessionListen::Listen(struct addrinfo* ai, int family, int backlog, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam, eCryptoAlgorithm CryptoAlgorithm)
{
	if(NULL == ai) { return 0; }
	if(NULL == cbfunc_Event) { return 0; }

	m_cbfunc_Event = cbfunc_Event;
	m_cbfunc_EventParam = cbfunc_EventParam;

	char reuse = 1;

	this->m_ListenSocket = ::socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
	if(this->m_ListenSocket == INVALID_SOCKET) {
//		printf("Can't create socket(1)\n");
		this->m_ListenSocket = -1;
		return 0;
	}

#if 0 // s̃G[̂߈U
	if(setsockopt(this->m_ListenSocket, SOL_SOCKET, SO_REUSEADDR, &reuse, sizeof(reuse)) == -1) {
#ifndef WIN32
		perror("setsockopt");
#endif // WIN32
//		printf("Can't create socket(2)\n");
		closesocket(this->m_ListenSocket);
		this->m_ListenSocket = -1;
		return 0;
	}
#endif

	if(bind(this->m_ListenSocket, ai->ai_addr, ai->ai_addrlen) == -1) {
#ifndef WIN32
		if(EADDRINUSE == errno) {
			// Linux̏ꍇipv4ipv6bindxKvȂ
		} else {
			perror("bind");
//			printf("Can't create socket(3)\n");
		}
#else // WIN32
//		printf("Can't create socket(3)\n");
#endif // WIN32
		closesocket(this->m_ListenSocket);
		this->m_ListenSocket = -1;
		return 0;
	}

	if(listen(this->m_ListenSocket, backlog) == -1) {
		closesocket(this->m_ListenSocket);
		this->m_ListenSocket = -1;
		return 0;
	}

	// RSAÍ𐶐
	if(0 > GenerateRSAKey(1024, RSA_F4)) {
		closesocket(this->m_ListenSocket);
		this->m_ListenSocket = -1;
		return 0;
	}

	m_CryptoAlgorithm = CryptoAlgorithm;
	return (this->m_ListenSocket);
}

//==============================================
// class CAquaNetworkSessionManager
//==============================================
CAquaNetworkSessionManager::CAquaNetworkSessionManager()
{
	m_SessionArray = NULL;
	m_SessionListenArray = NULL;
	m_UDPSessionArray = NULL;
	m_SessionArraySize = 0;
	m_SessionListenArraySize = 0;
	m_UDPSessionArraySize = 0;

#ifdef USEING_WINSOCK_SELECT
	m_hWndWinSockSelect = NULL;
#endif // USEING_WINSOCK_SELECT
#ifdef USEING_LIBEVENT
#ifdef WIN32
	m_hLibEventThread = NULL;
	m_LibEventThreadId = 0;
#endif // WIN32
#endif // USEING_LIBEVENT

#ifndef WIN32
	pthread_mutex_init(&m_ParseRecvSocketBufferThreadMutex, NULL);
	pthread_cond_init(&m_ParseRecvSocketBufferThreadCond, NULL);
#endif // WIN32

}
CAquaNetworkSessionManager::~CAquaNetworkSessionManager()
{
#ifdef USEING_WINSOCK_SELECT
	if(NULL != m_hWndWinSockSelect) {
		::DestroyWindow(m_hWndWinSockSelect);
	}
#endif // USEING_WINSOCK_SELECT

	ReleaseSessions();
	ReleaseListenSessions();
	ReleaseUDPSessions();

#ifndef WIN32
	pthread_cond_destroy(&m_ParseRecvSocketBufferThreadCond);
	pthread_mutex_destroy(&m_ParseRecvSocketBufferThreadMutex);
#endif // WIN32
}

int CAquaNetworkSessionManager::CreateSessions(int session_max)
{
	m_SessionArray = NULL;
	m_SessionArraySize = session_max;

	try {
		m_SessionArray = new CAquaNetworkSession[m_SessionArraySize];
	}
	catch(std::bad_alloc) {
		m_SessionArray = NULL;
		m_SessionArraySize = 0;
		return 0;
	}
	return 1;
}
int CAquaNetworkSessionManager::CreateListenSessions(int listen_session_max)
{
	m_SessionListenArray = NULL;
	m_SessionListenArraySize = listen_session_max;

	try {
		m_SessionListenArray = new CAquaNetworkSessionListen[m_SessionListenArraySize];
	}
	catch(std::bad_alloc) {
	m_SessionListenArray = NULL;
	m_SessionListenArraySize = 0;
		return 0;
	}
	return 1;
}
int CAquaNetworkSessionManager::CreateUDPSessions(int udp_session_max)
{
	m_UDPSessionArray = NULL;
	m_UDPSessionArraySize = udp_session_max;

	try {
		m_UDPSessionArray = new CAquaNetworkUDPSession[m_UDPSessionArraySize];
	}
	catch(std::bad_alloc) {
		m_UDPSessionArray = NULL;
		m_UDPSessionArraySize = 0;
		return 0;
	}
	return 1;
}
void CAquaNetworkSessionManager::ReleaseSessions(void)
{
	if(NULL != m_SessionArray) {
		delete [] m_SessionArray;
		m_SessionArray = NULL;
		m_SessionArraySize = 0;
	}
}
void CAquaNetworkSessionManager::ReleaseListenSessions(void)
{
	if(NULL != m_SessionListenArray) {
		delete [] m_SessionListenArray;
		m_SessionListenArray = NULL;
		m_SessionListenArraySize = 0;
	}
}
void CAquaNetworkSessionManager::ReleaseUDPSessions(void)
{
	if(NULL != m_UDPSessionArray) {
		delete [] m_UDPSessionArray;
		m_UDPSessionArray = NULL;
		m_UDPSessionArraySize = 0;
	}
}


#ifdef USEING_WINSOCK_SELECT
/** WinSockSelect
 * @param hInstance Win32AvP[VCX^Xnh
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaNetworkSessionManager::InitWinSockSelect(HINSTANCE hInstance)
{
	WNDCLASSEX wcx;
	TCHAR ClassName[] = _T("WinSockSelect");

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = CS_HREDRAW | CS_VREDRAW;
	wcx.lpfnWndProc = (WNDPROC)WinSockProc;
	wcx.cbClsExtra = 0;
	wcx.cbWndExtra = 0;
	wcx.hInstance = hInstance;
	wcx.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wcx.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcx.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
	wcx.lpszMenuName =  NULL;
	wcx.lpszClassName = ClassName;
	wcx.hIconSm = NULL;

	if (RegisterClassEx(&wcx) == 0) {
	
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL, GetLastError(), MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR) &lpMsgBuf, 0,	NULL);		
		MessageBox(NULL, (LPCTSTR)lpMsgBuf, _T("Error"), MB_OK | MB_ICONINFORMATION);
		LocalFree(lpMsgBuf);
		
		return 0;
	}

	m_hWndWinSockSelect = CreateWindow(ClassName,
		_T("WinSockSelect"),
		WS_OVERLAPPEDWINDOW,
		0, 0, 700, 700,
		NULL,
		NULL,
		hInstance,
		NULL
		);

#ifdef _WIN64
	SetWindowLongPtr(m_hWndWinSockSelect, GWLP_USERDATA, (LONG_PTR)this);
#else // _WIN64
	SetWindowLongPtr(m_hWndWinSockSelect, GWLP_USERDATA, (LONG)this);
#endif // _WIN64

	UnregisterClass(ClassName, hInstance);

	return 1;

}
#endif // USEING_WINSOCK_SELECT
#ifdef USEING_LIBEVENT
/** LibEvent̏
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaNetworkSessionManager::InitLibEvent(void)
{
	event_init();
	return 1;
}
/** LibEvent̔M
 * @retval 1:I
 * @retval 0:ُI
 */
int CAquaNetworkSessionManager::DispatchLibEvent(void)
{
#ifdef WIN32
	m_hLibEventThread = (HANDLE)_beginthreadex(NULL, 0x10000, (THREADFUNC)DispatchLibEventThreadFunc, NULL, 0, &m_LibEventThreadId); 
	if(NULL == m_hLibEventThread) {
		return 0;
	}
#else // WIN32
	int iRet = pthread_create(&m_hLibEventThread, NULL, DispatchLibEventThreadFunc, NULL);
	if(0 != iRet) {
		return 0;
	}
#endif // WIN32
	return 1;
}
#ifdef WIN32
/** LibEvent̔MpXbh֐
 * @retval 0:I
 * @retval 0:ُI
 */
DWORD CAquaNetworkSessionManager::DispatchLibEventThreadFunc(LPVOID lpvoid)
{
	event_dispatch();
	return 0L;
}
#else // WIN32
/** LibEvent̔MpXbh֐
 * @retval 0:I
 * @retval 0:ُI
 */
void* CAquaNetworkSessionManager::DispatchLibEventThreadFunc(LPVOID lpvoid)
{
	event_dispatch();
	return NULL;
}
#endif // WIN32
#endif // USEING_LIBEVENT

/// Mf[^͗pXbhJn
int CAquaNetworkSessionManager::CreateParseRecvSocketBufferThread(void)
{
#ifdef WIN32
	m_ParseRecvSocketBufferThreadHandle = (HANDLE)_beginthreadex(NULL, 0x10000, (THREADFUNC)ParseRecvSocketBufferThreadFunc, this, 0, &m_ParseRecvSocketBufferThreadId); 
	if(NULL == m_ParseRecvSocketBufferThreadHandle) {
		return 0;
	}
#else // WIN32
	int iRet = pthread_create(&m_ParseRecvSocketBufferThreadHandle, NULL, ParseRecvSocketBufferThreadFunc, this);
	if(0 != iRet) {
		return 0;
	}
#endif // WIN32
	return 1;
}
/// Mf[^͗pXbhTXyhԂɂ
void CAquaNetworkSessionManager::SuspendParseRecvSocketBufferThread(void)
{
#ifdef WIN32
	DWORD dwRet = SuspendThread(m_ParseRecvSocketBufferThreadHandle);
//	if(0xFFFFFFFF == dwRet) {
//		return 0L;
//	}
#else // WIN32
	pthread_mutex_lock(&m_ParseRecvSocketBufferThreadMutex);
	pthread_cond_wait(&m_ParseRecvSocketBufferThreadCond, &m_ParseRecvSocketBufferThreadMutex);
	pthread_mutex_unlock(&m_ParseRecvSocketBufferThreadMutex);
#endif // WIN32
}
/// Mf[^͗pXbhTXyhԂ
void CAquaNetworkSessionManager::ResumeParseRecvSocketBufferThread(void)
{
#ifdef WIN32
	DWORD dwRet = ResumeThread(m_ParseRecvSocketBufferThreadHandle);
//	if(0xFFFFFFFF == dwRet) {
//		return 0L;
//	}
#else // WIN32
	pthread_mutex_lock(&m_ParseRecvSocketBufferThreadMutex);
	pthread_cond_signal(&m_ParseRecvSocketBufferThreadCond);
	pthread_mutex_unlock(&m_ParseRecvSocketBufferThreadMutex);
#endif // WIN32
}
#ifdef WIN32
/// Mf[^͗pXbh֐
DWORD CAquaNetworkSessionManager::ParseRecvSocketBufferThreadFunc(LPVOID lpvoid)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)lpvoid;
	if(NULL == pAquaNetworkSessionManager) { return 0L; }

	while(1) {
		int parse_recv_socket_buffer_size_total = pAquaNetworkSessionManager->ParseRecvSocketBuffer();
		if(0 >= parse_recv_socket_buffer_size_total) {
			pAquaNetworkSessionManager->SuspendParseRecvSocketBufferThread();
		}
	}
	return 0L;
}
#else // WIN32
/// Mf[^͗pXbh֐
void* CAquaNetworkSessionManager::ParseRecvSocketBufferThreadFunc(LPVOID lpvoid)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)lpvoid;
	if(NULL == pAquaNetworkSessionManager) { return 0L; }

	while(1) {
		int parse_recv_socket_buffer_size_total = pAquaNetworkSessionManager->ParseRecvSocketBuffer();
		if(0 >= parse_recv_socket_buffer_size_total) {
			pAquaNetworkSessionManager->SuspendParseRecvSocketBufferThread();
		}
	}
	return NULL;
}
#endif // WIN32
/// Mf[^
int CAquaNetworkSessionManager::ParseRecvSocketBuffer(void)
{
	int parse_recv_socket_buffer_size_total = 0;
	for(int i=0; i<m_SessionArraySize; i++) {
		if(!m_SessionArray[i].IsUsed()) { continue; }
		int parse_recv_socket_buffer_size = m_SessionArray[i].parse_recv_socket_buffer();
		if(0 > parse_recv_socket_buffer_size) {
			m_SessionArray[i].call_cbfunc_Event(SESSION_EVENT_TYPE_FD_READ);
		} else if(0 < parse_recv_socket_buffer_size) {
			CryptoMessages messages = m_SessionArray[i].GetLastRecvCryptoMessages();
			for(CryptoMessages::iterator it=messages.begin(); it!=messages.end(); it++) {
				eCryptoMessageType CryptoMessageType = (*it);
				if(CRYPTO_MES_TYPE_PLAIN == CryptoMessageType ||
					CRYPTO_MES_TYPE_CRYPTOED == CryptoMessageType) {
					m_SessionArray[i].call_cbfunc_Event(SESSION_EVENT_TYPE_FD_READ);
					break;
				}
			}
			parse_recv_socket_buffer_size_total += parse_recv_socket_buffer_size;
		}
	}
	return parse_recv_socket_buffer_size_total;
}
/// ZbV̑҂󂯂Jn
int CAquaNetworkSessionManager::Listen(const char* service, int family, int backlog, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam, eCryptoAlgorithm CryptoAlgorithm)
{
#ifdef USEING_WINSOCK_SELECT
	if(NULL == m_hWndWinSockSelect) { return 0; }
#endif // USEING_WINSOCK_SELECT

	struct addrinfo hints;
	struct addrinfo* res = NULL;
	struct addrinfo* ai;
	int nsocks;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = family;
	hints.ai_flags = AI_PASSIVE;
	if(0 != getaddrinfo(NULL, service, &hints, &res)) { return 0; }

	for (nsocks = 0, ai = res; ai && nsocks < m_SessionListenArraySize; ai = ai->ai_next) {
		
		// sessionbgp
		CAquaNetworkSessionListen* new_session_listen = NULL;
		for(int i=0; i<m_SessionListenArraySize; i++) {
			if(!m_SessionListenArray[i].IsUsed()) {
				new_session_listen =  &(m_SessionListenArray[i]);
				break;
			}
		}
		if(NULL == new_session_listen) {
			return 0;
		}

		SOCKET listen_socket = new_session_listen->Listen(ai, family, backlog, cbfunc_Event, cbfunc_EventParam, CryptoAlgorithm);
		if(0 > listen_socket) { continue; }


#ifdef USEING_LIBEVENT
		new_session_listen->SetLibEvent(EV_READ, event_accept, this);
		if(new_session_listen->AddLibEvent(NULL) == -1) {
			new_session_listen->Close();
			continue;
		}
#endif // USEING_LIBEVENT
#ifdef USEING_WINSOCK_SELECT
		WSAAsyncSelect(listen_socket, m_hWndWinSockSelect, WM_SOCKET, FD_ACCEPT);
#endif // USEING_WINSOCK_SELECT


		new_session_listen->SetUsed(true);

		new_session_listen->SetListenService(service);
	
        nsocks++;
	}
	freeaddrinfo(res);
	return 1;
}
void CAquaNetworkSessionManager::CloseListen(const char* service)
{
	CAquaNetworkSessionListen* new_session_listen = NULL;
	for(int i=0; i<m_SessionListenArraySize; i++) {
		if(!m_SessionListenArray[i].IsUsed()) { continue; }
		if(0 != strcmp(m_SessionListenArray[i].GetListenService(), service)) { continue; }
		m_SessionListenArray[i].Close();
		m_SessionListenArray[i].SetUsed(false);
	}
}
/// \Pbgڑ󂯂
CAquaNetworkSession* CAquaNetworkSessionManager::Accept(CAquaNetworkSessionListen* pAquaNetworkSessionListen)
{
	if(NULL == pAquaNetworkSessionListen) { return NULL; }

	CAquaNetworkSession* new_session = NULL;

	for(int i=0; i<m_SessionArraySize; i++) {
		if(!m_SessionArray[i].IsUsed()) {
			new_session =  &(m_SessionArray[i]);
			break;
		}
	}
	if(NULL == new_session) {
		return NULL;
	}

	SOCKET s = new_session->accept(pAquaNetworkSessionListen);
	if(-1 == s) {
		return NULL;
	}
#ifdef USEING_LIBEVENT
	new_session->SetLibEventRead(EV_READ|EV_PERSIST, event_read, this);
	new_session->AddLibEventRead(NULL);
//	new_session->SetLibEventWrite(EV_WRITE|EV_PERSIST, event_write, this);
//	new_session->AddLibEventWrite(NULL);
#endif // USEING_LIBEVENT
#ifdef USEING_WINSOCK_SELECT
	WSAAsyncSelect(s, m_hWndWinSockSelect, WM_SOCKET, FD_READ | FD_CLOSE);
#endif // USEING_WINSOCK_SELECT

	// Íݒ
	new_session->SetCryptoAlgorithm(pAquaNetworkSessionListen->GetCryptoAlgorithm());

	new_session->SetUsed(true);

	return new_session;
}
/// ZbVƂ̐ڑJn
CAquaNetworkSession* CAquaNetworkSessionManager::Connect(bool bSecure, const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	CAquaNetworkSession* new_session = NULL;
	for(int i=0; i<m_SessionArraySize; i++) {
		if(!m_SessionArray[i].IsUsed()) {
			new_session =  &(m_SessionArray[i]);
			break;
		}
	}
	if(NULL == new_session) {
		return NULL;
	}

	new_session->SetUsed(true);

	// clientڑ
	SOCKET s = 0;
	if(bSecure) {
		s = new_session->connect_secure(hostname, service, cbfunc_Event, cbfunc_EventParam);
	} else {
		s = new_session->connect(hostname, service, cbfunc_Event, cbfunc_EventParam);
	}
	if(SOCKET_ERROR == s || INVALID_SOCKET == s) {
		new_session->SetUsed(false);
		return NULL;
	}

#ifdef USEING_LIBEVENT
	new_session->SetLibEventRead(EV_READ|EV_PERSIST, event_read, this);
	new_session->AddLibEventRead(NULL);
//	new_session->SetLibEventWrite(EV_WRITE|EV_PERSIST, event_write, this);
//	new_session->AddLibEventWrite(NULL);
#endif // USEING_LIBEVENT
#ifdef USEING_WINSOCK_SELECT
	WSAAsyncSelect(s, m_hWndWinSockSelect, WM_SOCKET, FD_READ | FD_CLOSE);
#endif // USEING_WINSOCK_SELECT

	return new_session;
}
/// ZbVƂ̐ڑJn
CAquaNetworkSession* CAquaNetworkSessionManager::Connect(const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	return Connect(false, hostname, service, cbfunc_Event, cbfunc_EventParam);
}
/// ZbVƂ̐ڑJn
CAquaNetworkSession* CAquaNetworkSessionManager::ConnectSecure(const char* hostname, const char* service, ty_cbfunc_Event cbfunc_Event, void* cbfunc_EventParam)
{
	return Connect(true, hostname, service, cbfunc_Event, cbfunc_EventParam);
}
/// ZbVƂ̐ڑؒf
int CAquaNetworkSessionManager::Close(CAquaNetworkSession* session)
{
	if(NULL == session) { return 0; }
	// clientؒf
	session->close();
	session->SetUsed(false);
	return 1;
}
/// UDPZbVJ
CAquaNetworkUDPSession* CAquaNetworkSessionManager::OpenUDPSession(int family, ty_cbfunc_UDPEvent cbfunc_UDPEvent, void* cbfunc_UDPEventParam)
{
	CAquaNetworkUDPSession* new_session = NULL;
	for(int i=0; i<m_UDPSessionArraySize; i++) {
		if(!m_UDPSessionArray[i].IsUsed()) {
			new_session =  &(m_UDPSessionArray[i]);
			break;
		}
	}
	if(NULL == new_session) {
		return NULL;
	}

	new_session->SetUsed(true);

	// clientڑ
	SOCKET s = new_session->make_socket(family, cbfunc_UDPEvent, cbfunc_UDPEventParam);
	if(SOCKET_ERROR == s || INVALID_SOCKET == s) {
		new_session->SetUsed(false);
		return NULL;
	}

	new_session->SetLibEventRead(EV_READ|EV_PERSIST, udp_event_read, this);
	new_session->AddLibEventRead(NULL);
//	new_session->SetLibEventWrite(EV_WRITE|EV_PERSIST, udp_event_write, this);
//	new_session->AddLibEventWrite(NULL);
	return new_session;
}
/// UDPZbV
void CAquaNetworkSessionManager::CloseUDPSession(CAquaNetworkUDPSession* session)
{
	if(NULL == session) { return; }
	session->close();
}
/// UDPBindZbVJ
int CAquaNetworkSessionManager::OpenUDPBindSession(const char* service, int family, ty_cbfunc_UDPEvent cbfunc_UDPEvent, void* cbfunc_UDPEventParam)
{
	struct addrinfo hints;
	struct addrinfo* res = NULL;
	struct addrinfo* ai;
	int nsocks;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = family;
	hints.ai_socktype = SOCK_DGRAM;
	hints.ai_flags = AI_PASSIVE;
	if(0 != getaddrinfo(NULL, service, &hints, &res)) { return 0; }

	for (nsocks = 0, ai = res; ai && nsocks < m_UDPSessionArraySize; ai = ai->ai_next) {
		
		// sessionbgp
		CAquaNetworkUDPSession* new_session = NULL;
		for(int i=0; i<m_UDPSessionArraySize; i++) {
			if(!m_UDPSessionArray[i].IsUsed()) {
				new_session =  &(m_UDPSessionArray[i]);
				break;
			}
		}
		if(NULL == new_session) {
			return 0;
		}

		SOCKET s = new_session->make_bind_socket(ai, cbfunc_UDPEvent, cbfunc_UDPEventParam);
		if(SOCKET_ERROR == s || INVALID_SOCKET == s) {
			continue;
		}
		new_session->SetLibEventRead(EV_READ, udp_event_read, this);
		if(new_session->AddLibEventRead(NULL) == -1) {
			new_session->close();
			continue;
		}

		new_session->SetUsed(true);

        nsocks++;
	}
	freeaddrinfo(res);
	return nsocks;
}
/// UDPBindZbV
void CAquaNetworkSessionManager::CloseUDPBindSession(const char* service)
{
	for(int i=0; i<m_UDPSessionArraySize; i++) {
		if(!m_UDPSessionArray[i].IsUsed()) { continue; }
		if(!m_UDPSessionArray[i].IsBind()) { continue; }
		if(0 != strcmp(m_UDPSessionArray[i].GetBindService(), service)) { continue; }
		m_UDPSessionArray[i].close();
		m_UDPSessionArray[i].SetUsed(false);
	}
}
/// \PbgIDZbVp҂󂯃IuWFNg擾
CAquaNetworkSessionListen* CAquaNetworkSessionManager::GetAquaNetworkSessionListen(SOCKET s)
{
	for(int i=0; i<m_SessionListenArraySize; i++) {
		if(!m_SessionListenArray[i].IsUsed()) { continue; }
		if(s != m_SessionListenArray[i].GetSocket()) { continue; }
		return &(m_SessionListenArray[i]);
	}
	return NULL;
}
/// \PbgIDZbVpIuWFNg擾
CAquaNetworkSession* CAquaNetworkSessionManager::GetAquaNetworkSession(SOCKET s)
{
	for(int i=0; i<m_SessionArraySize; i++) {
		if(!m_SessionArray[i].IsUsed()) { continue; }
		if(s != m_SessionArray[i].GetSocket()) { continue; }
		return &(m_SessionArray[i]);

	}
	return NULL;
}

/// \PbgIDZbVpIuWFNg擾
CAquaNetworkUDPSession* CAquaNetworkSessionManager::GetAquaNetworkUDPSession(SOCKET s)
{
	for(int i=0; i<m_UDPSessionArraySize; i++) {
		if(!m_UDPSessionArray[i].IsUsed()) { continue; }
		if(s != m_UDPSessionArray[i].GetSocket()) { continue; }
		return &(m_UDPSessionArray[i]);

	}
	return NULL;
}
#ifdef USEING_WINSOCK_SELECT
/// \PbgCxgEBhER[obN֐
LRESULT CALLBACK CAquaNetworkSessionManager::WinSockProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HINSTANCE hInstance = (HINSTANCE)GetWindowLongPtr(hwnd, GWLP_HINSTANCE);

	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)GetWindowLongPtr(hwnd, GWLP_USERDATA);
	
	CAquaNetworkSessionListen* pAquaNetworkSessionListen = NULL;
	CAquaNetworkSession* pAquaNetworkSession = NULL;
	SOCKET s = 0;

	switch (uMsg) {
	case WM_CREATE:
		return 0;

	case WM_COMMAND:
		return 0;

	case WM_SOCKET:
		s = (SOCKET)wParam;
		switch (WSAGETSELECTEVENT(lParam)) {
		case FD_ACCEPT:
			if(NULL != pAquaNetworkSessionManager) {
				pAquaNetworkSessionListen = pAquaNetworkSessionManager->GetAquaNetworkSessionListen(s);
				if(NULL != pAquaNetworkSessionListen) {
					pAquaNetworkSession = pAquaNetworkSessionManager->Accept(pAquaNetworkSessionListen);
					if(NULL != pAquaNetworkSession) {
						pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_ACCEPT);
					}
				}
			}
			break;
		case FD_CONNECT:
			if(NULL != pAquaNetworkSessionManager) {
				pAquaNetworkSession = pAquaNetworkSessionManager->GetAquaNetworkSession(s);
				if(NULL != pAquaNetworkSession) {
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_CONNECT);
				}
			}
			break;

		case FD_READ:
			if(NULL != pAquaNetworkSessionManager) {
				pAquaNetworkSession = pAquaNetworkSessionManager->GetAquaNetworkSession(s);
				if(NULL != pAquaNetworkSession) {
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_READ);
				}
			}
			break;

		case FD_CLOSE:
			if(NULL != pAquaNetworkSessionManager) {
				pAquaNetworkSession = pAquaNetworkSessionManager->GetAquaNetworkSession(s);
				if(NULL != pAquaNetworkSession) {
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_CLOSE);
					pAquaNetworkSession->SetUsed(false);
				}
			}
			break;
		}
		return 0;
	case WM_DESTROY:
		return 0;
	}

	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}
#endif // USEING_WINSOCK_SELECT

#ifdef USEING_LIBEVENT
/// \PbgCxgR[obN֐(accept)
void CAquaNetworkSessionManager::event_accept(const int listenfd, short libevent, void *argv)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)argv;
	CAquaNetworkSessionListen* pAquaNetworkSessionListen = NULL;
	CAquaNetworkSession* pAquaNetworkSession = NULL;

	if(libevent & EV_READ) {
		if(NULL != pAquaNetworkSessionManager) {
			pAquaNetworkSessionListen = pAquaNetworkSessionManager->GetAquaNetworkSessionListen(listenfd);
			if(NULL != pAquaNetworkSessionListen) {
				pAquaNetworkSession = pAquaNetworkSessionManager->Accept(pAquaNetworkSessionListen);
				if(NULL != pAquaNetworkSession) {
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_ACCEPT);
				}
				pAquaNetworkSessionListen->AddLibEvent(NULL);
			}
		}
	}

}
/// \PbgCxgR[obN֐(read)
void CAquaNetworkSessionManager::event_read(const int sockfd, short libevent, void *argv)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)argv;
	CAquaNetworkSession* pAquaNetworkSession = NULL;

	if(libevent & EV_READ) {
		if(NULL != pAquaNetworkSessionManager) {
			pAquaNetworkSession = pAquaNetworkSessionManager->GetAquaNetworkSession(sockfd);
			if(NULL != pAquaNetworkSession) {
				int recv_data_length = pAquaNetworkSession->recv();
				if(0 > recv_data_length) {
					// \PbgG[܂̓\PbgN[Y
					// ܂freesG[̉\
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_READ);
				} else if(0 == recv_data_length) {
					// \PbgG[܂̓\PbgN[Y
					// ܂freesG[̉\
					pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_CLOSE);
				} else {
					pAquaNetworkSessionManager->ResumeParseRecvSocketBufferThread();
				}
			}
		}
	}
}
/// \PbgCxgR[obN֐(write)
void CAquaNetworkSessionManager::event_write(const int sockfd, short libevent, void *argv)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)argv;
	CAquaNetworkSession* pAquaNetworkSession = NULL;

	if(libevent & EV_WRITE) {
		if(NULL != pAquaNetworkSessionManager) {
			pAquaNetworkSession = pAquaNetworkSessionManager->GetAquaNetworkSession(sockfd);
			if(NULL != pAquaNetworkSession) {
				pAquaNetworkSession->call_cbfunc_Event(SESSION_EVENT_TYPE_FD_WRITE);
			}
		}
	}
}
/// \PbgCxgR[obN֐(read)
void CAquaNetworkSessionManager::udp_event_read(const int sockfd, short libevent, void *argv)
{
	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)argv;
	CAquaNetworkUDPSession* pAquaNetworkUDPSession = NULL;

	if(libevent & EV_READ) {
		if(NULL != pAquaNetworkSessionManager) {
			pAquaNetworkUDPSession = pAquaNetworkSessionManager->GetAquaNetworkUDPSession(sockfd);
			if(NULL != pAquaNetworkUDPSession) {
				pAquaNetworkUDPSession->call_cbfunc_UDPEvent(SESSION_EVENT_TYPE_FD_READ);
				pAquaNetworkUDPSession->AddLibEventRead(NULL);
			}
		}
	}

}
/// \PbgCxgR[obN֐(write)
void CAquaNetworkSessionManager::udp_event_write(const int sockfd, short libevent, void *argv)
{

	CAquaNetworkSessionManager* pAquaNetworkSessionManager = (CAquaNetworkSessionManager*)argv;
	CAquaNetworkUDPSession* pAquaNetworkUDPSession = NULL;

	if(libevent & EV_WRITE) {
		if(NULL != pAquaNetworkSessionManager) {
			pAquaNetworkUDPSession = pAquaNetworkSessionManager->GetAquaNetworkUDPSession(sockfd);
			if(NULL != pAquaNetworkUDPSession) {
				pAquaNetworkUDPSession->call_cbfunc_UDPEvent(SESSION_EVENT_TYPE_FD_WRITE);
			}
		}
	}

}
#endif // USEING_LIBEVENT




//==============================================
// class CAquaNetworkUDPSession
//==============================================
CAquaNetworkUDPSession::CAquaNetworkUDPSession()
{
	m_bUsed = false;
	m_bBind = false;
	m_Socket = INVALID_SOCKET;
	m_family = AF_UNSPEC;
	memset(m_BindService, 0, sizeof(m_BindService));
}
CAquaNetworkUDPSession::~CAquaNetworkUDPSession()
{
}
/// gptO擾
bool CAquaNetworkUDPSession::IsUsed() const
{
	return m_bUsed;
}
/// gptOݒ
void CAquaNetworkUDPSession::SetUsed(bool bFlag)
{
	m_bUsed = bFlag;

	if(!m_bUsed) {
		close();
	}
}
/// BindSessionǂ
bool CAquaNetworkUDPSession::IsBind() const
{
	return m_bBind;
}
// BindT[rX擾
const char* CAquaNetworkUDPSession::GetBindService(void) const
{
	return m_BindService;
}
// BindT[rXݒ
void CAquaNetworkUDPSession::SetBindService(const char* service)
{
	if(NULL == service) { return; }
	strncpy(m_BindService, service, sizeof(m_BindService));
}
/// \Pbg擾
SOCKET CAquaNetworkUDPSession::GetSocket(void)
{
	return m_Socket;
}
/// \Pbg擾(const)
SOCKET CAquaNetworkUDPSession::GetSocket(void) const
{
	return m_Socket;
}
#ifdef USEING_LIBEVENT
/// MCxg̐ݒ
void CAquaNetworkUDPSession::SetLibEventRead(short libevent, void(*fn)(int, short, void *), void* arg)
{
	return event_set(&m_LibEventRead, m_Socket, libevent, fn, arg);
}
/// MCxg̒ǉ
int CAquaNetworkUDPSession::AddLibEventRead(struct timeval* tv)
{
	m_bLibEventReadFlag = true;
	return event_add(&m_LibEventRead, tv);
}
/// MCxg̍폜
int CAquaNetworkUDPSession::DelLibEventRead(void)
{
	if(m_bLibEventReadFlag) {
		m_bLibEventReadFlag = false;
		return event_del(&m_LibEventRead);
	}
	return -1;
}
/// MCxg̐ݒ
void CAquaNetworkUDPSession::SetLibEventWrite(short libevent, void(*fn)(int, short, void *), void* arg)
{
	return event_set(&m_LibEventWrite, m_Socket, libevent, fn, arg);
}
/// MCxg̒ǉ
int CAquaNetworkUDPSession::AddLibEventWrite(struct timeval* tv)
{
	m_bLibEventWriteFlag = true;
	return event_add(&m_LibEventWrite, tv);
}
/// MCxg̍폜
int CAquaNetworkUDPSession::DelLibEventWrite(void)
{
	if(m_bLibEventWriteFlag) {
		m_bLibEventWriteFlag = false;
		return event_del(&m_LibEventWrite);
	}
	return -1;
}
#endif // USEING_LIBEVENT

/// UDPZbV쐬
SOCKET CAquaNetworkUDPSession::make_socket(int family, ty_cbfunc_UDPEvent cbfunc_UDPEvent, void* cbfunc_UDPEventParam)
{
	SOCKET s = ::socket(family, SOCK_DGRAM, 0);
	if(s == INVALID_SOCKET){
		return INVALID_SOCKET;
	}
	m_Socket = s;
	m_family = family;
	m_cbfunc_UDPEvent = cbfunc_UDPEvent;
	m_cbfunc_UDPEventParam = cbfunc_UDPEventParam;
	m_SokcetState = SOCKET_STATE_NORMAL;
	return m_Socket;
}

SOCKET CAquaNetworkUDPSession::make_bind_socket(struct addrinfo* ai, ty_cbfunc_UDPEvent cbfunc_UDPEvent, void* cbfunc_UDPEventParam)
{
	if(NULL == ai) { return INVALID_SOCKET; }
	if(NULL == cbfunc_UDPEvent) { return INVALID_SOCKET; }

	SOCKET Socket = ::socket(ai->ai_family, ai->ai_socktype, ai->ai_protocol);
	if(Socket == INVALID_SOCKET) {
		return INVALID_SOCKET;
	}

	if(bind(Socket, ai->ai_addr, ai->ai_addrlen) == -1) {
		closesocket(Socket);
		return INVALID_SOCKET;
	}
	m_Socket = Socket;
	m_family = ai->ai_family;
	m_cbfunc_UDPEvent = cbfunc_UDPEvent;
	m_cbfunc_UDPEventParam = cbfunc_UDPEventParam;
	m_bBind = true;
	return m_Socket;
}

/// M֐
int CAquaNetworkUDPSession::recvfrom(void* buf, size_t len, int flags, struct sockaddr* from, socklen_t* fromlen)
{
	int recvlen = ::recvfrom(m_Socket, (char*)buf, len, flags, from, fromlen);
	return recvlen;
}
/// M֐
int CAquaNetworkUDPSession::sendto(const void* buf, size_t len, int flags, const struct sockaddr* to, socklen_t tolen)
{
	int sendlen = ::sendto(m_Socket, (char*)buf, len, flags, to, tolen);
	return sendlen;
}

/// UDPZbV
void CAquaNetworkUDPSession::close(void)
{
	if(INVALID_SOCKET == m_Socket) { return; }
	closesocket(m_Socket);
	m_Socket = INVALID_SOCKET;
	m_bBind = false;
}
/// MR[obN֐̌Ăяo
int CAquaNetworkUDPSession::call_cbfunc_UDPEvent(short ev)
{
	int iRet = 1;
	if(NULL != m_cbfunc_UDPEvent) {
		iRet = m_cbfunc_UDPEvent(this, ev, m_cbfunc_UDPEventParam);
	}
	return iRet;
}

}

