#include <openssl/crypto.h>
#include <openssl/evp.h>
#include <openssl/rand.h>
#include <openssl/bio.h>
#include <openssl/rsa.h>

#include <string.h>

#include "CryptFunction.h"

//#ifdef WIN32
//#pragma comment(lib, "libeay32MT.lib")
//#endif // WIN32

// encrypt and decrypt dummy key
const unsigned char key[EVP_MAX_KEY_LENGTH] = {0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef, 0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef, 0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef, 0x01,0x23,0x45,0x67,0x89,0xab,0xcd,0xef};
const unsigned char iv[EVP_MAX_IV_LENGTH] = {0x12,0x34,0x56,0x78,0x90,0xab,0xcd,0xef, 0x12,0x34,0x56,0x78,0x90,0xab,0xcd,0xef};
#define USE_CRYPTOKEY

/** 
 * Í
 * @param ctx ÍReLXgIuWFNgւ̃|C^
 * @param input Íϐւ̃|C^
 * @param output Íʂi[ϐւ̃|C^
 * @param length Íϐ̃TCY
 * @retval Í̃TCY
 */
static int encrypt(EVP_CIPHER_CTX* ctx, unsigned char* output, long output_length, const unsigned char* input, long input_length)
{
	int cipherlen, tmplen;
	if (!EVP_EncryptUpdate(ctx, output, &cipherlen, input, input_length)) {
		return -1;
	}

	if (!EVP_EncryptFinal(ctx, output+cipherlen, &tmplen)) {
		return -1;
	}
	cipherlen += tmplen;
	return cipherlen; 
}
/** 
 * 
 * @param ctx ReLXgIuWFNgւ̃|C^
 * @param input ϐւ̃|C^
 * @param output ʂi[ϐւ̃|C^
 * @param length ϐ̃TCY
 * @retval ̃TCY
 */
static int decrypt(EVP_CIPHER_CTX* ctx, unsigned char* output, long output_length, const unsigned char* input, long input_length)
{
	int plainlen, tmplen;
	if (!EVP_DecryptUpdate(ctx, output, &plainlen, input, input_length)) {
		return -1;
	}

	if (!EVP_DecryptFinal(ctx, output+plainlen,&tmplen)) {
		return -1;
	}
	plainlen += tmplen;
	return plainlen; 
}

void select_random_key(unsigned char* key, int b)
{
	RAND_bytes(key, b);
}
void select_random_iv(unsigned char* iv, int b)
{
	RAND_bytes(iv, b);
}
int get_key_length_DES_EDE3(void)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
	EVP_EncryptInit(&ctx, EVP_des_ede3_cbc(), NULL, NULL);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return keylen; 
}
int get_key_length_BF(void)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
	EVP_EncryptInit(&ctx, EVP_bf_cbc(), NULL, NULL);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return keylen; 
}
int get_iv_length_DES_EDE3(void)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
	EVP_EncryptInit(&ctx, EVP_des_ede3_cbc(), NULL, NULL);
	int ivlen = EVP_CIPHER_CTX_iv_length(&ctx);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return ivlen; 
}
int get_iv_length_BF(void)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
	EVP_EncryptInit(&ctx, EVP_bf_cbc(), NULL, NULL);
	int ivlen = EVP_CIPHER_CTX_iv_length(&ctx);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return ivlen; 
}


int encrypt_DES_EDE3(unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* plain_data, long plain_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
#ifdef USE_CRYPTOKEY
	EVP_EncryptInit(&ctx, EVP_des_ede3_cbc(), crypto_key, crypto_iv);
	EVP_CIPHER_CTX_set_key_length(&ctx, crypto_key_length);
	EVP_EncryptInit(&ctx, NULL, crypto_key, NULL);
#else // USE_CRYPTOKEY
	EVP_EncryptInit(&ctx, EVP_des_ede3_cbc(), key, iv);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_set_key_length(&ctx, keylen);
	EVP_EncryptInit(&ctx, NULL, key, NULL);
#endif // USE_CRYPTOKEY
	// Í
	int iRet = encrypt(&ctx, encrypt_data, encrypt_data_length, plain_data, plain_data_length);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return iRet; 
}

int decrypt_DES_EDE3(unsigned char* decrypt_data, long decrypt_data_length, const unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
#ifdef USE_CRYPTOKEY
	EVP_DecryptInit(&ctx, EVP_des_ede3_cbc(), crypto_key, crypto_iv);
	EVP_CIPHER_CTX_set_key_length(&ctx, crypto_key_length);
	EVP_DecryptInit(&ctx, NULL, crypto_key, NULL);
#else // USE_CRYPTOKEY
	EVP_DecryptInit(&ctx, EVP_des_ede3_cbc(), key, iv);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_set_key_length(&ctx, keylen);
	EVP_DecryptInit(&ctx, NULL, key, NULL);
#endif // USE_CRYPTOKEY
	// 
	int iRet = decrypt((EVP_CIPHER_CTX*)&ctx, decrypt_data, decrypt_data_length, encrypt_data, encrypt_data_length);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return iRet;
}

int encrypt_BF(unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* plain_data, long plain_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
#ifdef USE_CRYPTOKEY
	EVP_EncryptInit(&ctx, EVP_bf_cbc(), crypto_key, crypto_iv);
	EVP_CIPHER_CTX_set_key_length(&ctx, crypto_key_length);
	EVP_EncryptInit(&ctx, NULL, crypto_key, NULL);
#else // USE_CRYPTOKEY
	EVP_EncryptInit(&ctx, EVP_bf_cbc(), key, iv);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_set_key_length(&ctx, keylen);
	EVP_EncryptInit(&ctx, NULL, key, NULL);
#endif
	// Í
	int iRet = encrypt(&ctx, encrypt_data, encrypt_data_length, plain_data, plain_data_length);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return iRet; 
}

int decrypt_BF(unsigned char* decrypt_data, long decrypt_data_length, const unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length)
{
	EVP_CIPHER_CTX ctx;
	EVP_CIPHER_CTX_init(&ctx);
#ifdef USE_CRYPTOKEY
	EVP_DecryptInit(&ctx, EVP_bf_cbc(), crypto_key, crypto_iv);
	EVP_CIPHER_CTX_set_key_length(&ctx, crypto_key_length);
	EVP_DecryptInit(&ctx, NULL, crypto_key, NULL);
#else // USE_CRYPTOKEY
	EVP_DecryptInit(&ctx, EVP_bf_cbc(), key, iv);
	int keylen = EVP_CIPHER_CTX_key_length(&ctx);
	EVP_CIPHER_CTX_set_key_length(&ctx, keylen);
	EVP_DecryptInit(&ctx, NULL, key, NULL);
#endif // USE_CRYPTOKEY
	// 
	int iRet = decrypt((EVP_CIPHER_CTX*)&ctx, decrypt_data, decrypt_data_length, encrypt_data, encrypt_data_length);
	EVP_CIPHER_CTX_cleanup(&ctx);
	return iRet;
}

int RSA_generate_key_der(int bits, unsigned long e, unsigned char* private_key, int* private_key_length, unsigned char* public_key, int* public_key_length)
{
	if(1024 > bits) { return -1; }
	if(NULL == private_key) { return -1; }
	if(NULL == private_key_length) { return -1; }
	if(NULL == public_key) { return 0; }
	if(NULL == public_key_length) { return -1; }

	RSA* rsa = RSA_generate_key(bits, e, NULL, NULL);
	if(NULL == rsa) { return -1; }

	unsigned char** key = NULL;

	key = &private_key;
	*private_key_length = ::i2d_RSAPrivateKey(rsa, NULL);
	::i2d_RSAPrivateKey(rsa, key);

	key = &public_key;
	*public_key_length = ::i2d_RSAPublicKey(rsa, NULL);
	::i2d_RSAPublicKey(rsa, key);

	RSA_free(rsa);

	return ((*private_key_length) + (*public_key_length));
}

int RSA_public_encrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* public_key, int public_key_length)
{
	if(0 >= flen) { return -1; }
	if(NULL == from) { return -1; }
	if(NULL == to) { return -1; }
	if(NULL == public_key) { return -1; }
	if(0 >= public_key_length) { return -1; }

	RSA* rsa = ::d2i_RSAPublicKey(NULL, &public_key, public_key_length);
	if(NULL == rsa) { return -1; }
	
	int iRet = RSA_public_encrypt(flen, from, to, rsa, RSA_PKCS1_OAEP_PADDING);
	RSA_free(rsa);
	return iRet;
}

int RSA_private_encrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* private_key, int private_key_length)
{
	if(0 >= flen) { return -1; }
	if(NULL == from) { return -1; }
	if(NULL == to) { return -1; }
	if(NULL == private_key) { return -1; }
	if(0 >= private_key_length) { return -1; }

	RSA* rsa = ::d2i_RSAPrivateKey(NULL, &private_key, private_key_length);
	if(NULL == rsa) { return -1; }
	
	int iRet = RSA_private_encrypt(flen, from, to, rsa, RSA_PKCS1_OAEP_PADDING);
	RSA_free(rsa);
	return iRet;
}

int RSA_public_decrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* public_key, int public_key_length)
{
	if(0 >= flen) { return -1; }
	if(NULL == from) { return -1; }
	if(NULL == to) { return -1; }
	if(NULL == public_key) { return -1; }
	if(0 >= public_key_length) { return -1; }

	RSA* rsa = ::d2i_RSAPublicKey(NULL, &public_key, public_key_length);
	if(NULL == rsa) { return -1; }
	
	int iRet = RSA_public_decrypt(flen, from, to, rsa, RSA_PKCS1_OAEP_PADDING);
	RSA_free(rsa);
	return iRet;
}

int RSA_private_decrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* private_key, int private_key_length)
{
	if(0 >= flen) { return -1; }
	if(NULL == from) { return -1; }
	if(NULL == to) { return -1; }
	if(NULL == private_key) { return -1; }
	if(0 >= private_key_length) { return -1; }

	RSA* rsa = ::d2i_RSAPrivateKey(NULL, &private_key, private_key_length);
	if(NULL == rsa) { return -1; }
	
	int iRet = RSA_private_decrypt(flen, from, to, rsa, RSA_PKCS1_OAEP_PADDING);
	RSA_free(rsa);
	return iRet;
}
