#ifndef _CRYPT_FUNCTION_H_
#define _CRYPT_FUNCTION_H_

#define PLAIN_DATA_MAXLEN	25000

#ifndef EVP_MAX_KEY_LENGTH
#define EVP_MAX_KEY_LENGTH	32
#endif // EVP_MAX_KEY_LENGTH

#ifndef EVP_MAX_IV_LENGTH
#define	EVP_MAX_IV_LENGTH	16
#endif //  EVP_MAX_IV_LENGTH	16

#define RSA_MAX_KEY_LENGTH	65535

#ifndef RSA_3
#define RSA_3	0x3L
#endif // RSA_3
#ifndef RSA_F4
#define RSA_F4	0x10001L
#endif // RSA_F4	0x10001L

void select_random_key(unsigned char* key, int b);
void select_random_iv(unsigned char* iv, int b);
int get_key_length_DES_EDE3(void);
int get_key_length_BF(void);
int get_iv_length_DES_EDE3(void);
int get_iv_length_BF(void);

int encrypt_DES_EDE3(unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* plain_data, long plain_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length);
int decrypt_DES_EDE3(unsigned char* decrypt_data, long decrypt_data_length, const unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length);

int encrypt_BF(unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* plain_data, long plain_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length);
int decrypt_BF(unsigned char* decrypt_data, long decrypt_data_length, const unsigned char* encrypt_data, long encrypt_data_length, const unsigned char* crypto_key, int crypto_key_length, const unsigned char* crypto_iv, int crypto_iv_length);

int RSA_generate_key_der(int bits, unsigned long e, unsigned char* private_key, int* private_key_length, unsigned char* public_key, int* public_key_length);
int RSA_public_encrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* public_key, int public_key_length);
int RSA_private_encrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* private_key, int private_key_length);
int RSA_public_decrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* public_key, int public_key_length);
int RSA_private_decrypt_der(int flen, const unsigned char *from, unsigned char *to, const unsigned char* private_key, int private_key_length);

#endif // _CRYPT_FUNCTION_H_

