#include <winsock2.h>
#include <ws2tcpip.h>
#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <new>
#include <tchar.h>
#include <time.h>

#include "AquaMessageSystem.h"
using namespace AquaMessageSystem;

#pragma comment(lib, "ws2_32.lib")

#define APPWINDOW_WIDTH			640
#define APPWINDOW_HEIGHT		480
#define APPWINDOW_CLASS		_T("MAIN_WINDOW")

#define RECV_BUUFER_SIZE				4096


//#define CONNECT_HOSTNAME_TCP	"localhost"
//#define CONNECT_HOSTNAME_TCP	"192.168.2.141"
#define CONNECT_HOSTNAME_TCP	"fe80::20c:29ff:fea1:9675%7"
#define CONNECT_SERVICE_TCP		"30000"
//#define CONNECT_HOSTNAME_UDP	"localhost"
//#define CONNECT_HOSTNAME_UDP	"192.168.2.141"
#define CONNECT_HOSTNAME_UDP	"fe80::20c:29ff:fea1:9675%7"
#define CONNECT_SERVICE_UDP		"20001"

#ifdef _DEBUG
#pragma comment(lib, "./AquaMessageSystemMTd.lib")
#else // _DEBUG
#pragma comment(lib, "./AquaMessageSystemMT.lib")
#endif // _DEBUG

typedef unsigned THREADID;
typedef unsigned (WINAPI *THREADFUNC)(LPVOID);

BOOL InitApp(HINSTANCE hInstance, int nCmdShow);
LRESULT CALLBACK WndProc ( HWND, UINT, WPARAM, LPARAM );

BOOL g_bConnectServerFlag = FALSE;
TCHAR uid[UID_LEN_MAX] = _T("uid01"); 
TCHAR passwd[PASSWD_LEN_MAX] = _T("password01"); 

TCHAR uid_to[UID_LEN_MAX] = _T("uid02"); 
TCHAR tcp_message_data[64] = _T("test tcp message"); 
TCHAR udp_message_data[64] = _T("test udp message"); 

BOOL g_bAppEnd = FALSE;

static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host_str, size_t host_strlen)
{
	if(NULL == sa) { return; }

	char host[NI_MAXHOST] = "";
	char serv[NI_MAXSERV] = "";
	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv6)", host, serv);
		} else {
			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, sizeof(host), serv, sizeof(serv),
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 == error) {
			_snprintf(host_str, host_strlen, "%s:%s(ipv4)", host, serv);
		} else {
			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host_str, host_strlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host_str, host_strlen, "unknown");
	} else {
		_snprintf(host_str, host_strlen, "unknown");
	}
}
static void addr2str(const struct sockaddr *sa, socklen_t salen, char* host, size_t hostlen, char* serv, size_t servlen)
{
	if(NULL == sa) { return; }
	if(NULL == host) { return; }
	if(NULL == serv) { return; }

	int error = 0;

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		error = getnameinfo(sa, sizeof(struct sockaddr_in6), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		error = getnameinfo(sa, sizeof(struct sockaddr_in), host, hostlen, serv, servlen,
							NI_NUMERICHOST | NI_NUMERICSERV);
		if(0 != error) {
			printf("getnameinfo : %s\n", gai_strerror(error));
			_snprintf(host, hostlen, "unknown");
			_snprintf(serv, servlen, "unknown");
		}
	} else if(AF_UNSPEC == sa->sa_family) {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	} else {
		_snprintf(host, hostlen, "unknown");
		_snprintf(serv, servlen, "unknown");
	}
}

int recv_user_message(CAquaMessageSession* session, const char* hostname, const char* service, const void* pMessageData, size_t nMessageData)
{
	TCHAR szBuff[RECV_BUUFER_SIZE+256] = _T("\0");

	TCHAR timestamp[32] = _T("\0");
	time_t now_time;							// time֐p
	struct tm *now_time_local;
	time(&now_time);							// 擾
	now_time_local = localtime(&now_time);		// nԂ̍\̂ɕϊ

	memset(timestamp, '\0', sizeof(timestamp));
	_sntprintf(timestamp, sizeof(timestamp)-1, _T("%04d-%02d-%02d %02d:%02d:%02d"),
	 now_time_local->tm_year + 1900,
	 now_time_local->tm_mon + 1,
	 now_time_local->tm_mday,
	 now_time_local->tm_hour,
	 now_time_local->tm_min,
	 now_time_local->tm_sec);

	// recv from user message
	tagMessageDataUserMessage MessageDataUserMessage;
	memcpy(&MessageDataUserMessage, pMessageData, sizeof(tagMessageDataUserMessage));

	FILE* pFile = fopen("ClientMessage.log", "at");
	if(NULL != pFile) {
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, sizeof(szBuff) - 1, _T(" [%s]  USER_MESSAGE data %s"), timestamp, MessageDataUserMessage.m_message);
		_ftprintf(pFile, _T("%s\n"), szBuff);

		fclose(pFile);
	}

	return 1;
}
int session_event(CAquaMessageSession* session, const char* hostname, const char* service, const void* pMessageData, size_t nMessageData)
{
	TCHAR szBuff[RECV_BUUFER_SIZE+256] = _T("\0");

	TCHAR timestamp[32] = _T("\0");
	time_t now_time;							// time֐p
	struct tm *now_time_local;
	time(&now_time);							// 擾
	now_time_local = localtime(&now_time);		// nԂ̍\̂ɕϊ

	memset(timestamp, '\0', sizeof(timestamp));
	_sntprintf(timestamp, sizeof(timestamp)-1, _T("%04d-%02d-%02d %02d:%02d:%02d"),
	 now_time_local->tm_year + 1900,
	 now_time_local->tm_mon + 1,
	 now_time_local->tm_mday,
	 now_time_local->tm_hour,
	 now_time_local->tm_min,
	 now_time_local->tm_sec);

	// recv from user message
	tagMessageDataSesssionEvent MessageDataSesssionEvent;
	memcpy(&MessageDataSesssionEvent, pMessageData, sizeof(tagMessageDataSesssionEvent));

	FILE* pFile = fopen("ClientAccess.log", "at");
	if(NULL == pFile) {
		return 1;
	}

	struct sockaddr* sa = (struct sockaddr*)&(MessageDataSesssionEvent.m_SessionAddr);

	char m_local_host[NI_MAXHOST];						/// ڑzXg
	char m_local_serv[NI_MAXSERV];						/// ڑT[rX
	char m_foreign_host[NI_MAXHOST];						/// ڑzXg
	char m_foreign_serv[NI_MAXSERV];						/// ڑT[rX

	memset(m_local_host, '\0', sizeof(m_local_host));
	memset(m_local_serv, '\0', sizeof(m_local_serv));
	memset(m_foreign_host, '\0', sizeof(m_foreign_host));
	memset(m_foreign_serv, '\0', sizeof(m_foreign_serv));

	char LocalAddress[NI_MAXHOST+NI_MAXSERV+10] = "unknown";
	char ForeignAddress[NI_MAXHOST+NI_MAXSERV+10] = "unknown";

	if(AF_INET6 == sa->sa_family) {
		// ipv6
		addr2str((struct sockaddr*)sa, sizeof(struct sockaddr_in6), m_foreign_host, sizeof(m_foreign_host), m_foreign_serv, sizeof(m_foreign_serv));
		_snprintf(ForeignAddress, sizeof(ForeignAddress), "%s:%s", m_foreign_host, m_foreign_serv);
	} else if(AF_INET == sa->sa_family) {
		// ipv4
		addr2str((struct sockaddr*)sa, sizeof(struct sockaddr_in), m_foreign_host, sizeof(m_foreign_host), m_foreign_serv, sizeof(m_foreign_serv));
		_snprintf(ForeignAddress, sizeof(ForeignAddress), "%s:%s", m_foreign_host, m_foreign_serv);
	} else {
		fclose(pFile);
		return 1;
	}

	switch(MessageDataSesssionEvent.m_ev) {
	case AQUAMESSYS_SESSION_EVENT_TYPE_FD_ACCEPT:
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, sizeof(szBuff) - 1, _T("%s - - [%s] SESSION_ACCEPT"), ForeignAddress, timestamp);
		_ftprintf(pFile, _T("%s\n"), szBuff);
		break;
	case AQUAMESSYS_SESSION_EVENT_TYPE_FD_CONNECT:
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, sizeof(szBuff) - 1, _T("%s - -  [%s]  SESSION_CONNECT"), ForeignAddress, timestamp);
		_ftprintf(pFile, _T("%s\n"), szBuff);
		break;
	case AQUAMESSYS_SESSION_EVENT_TYPE_FD_CLOSE:
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, sizeof(szBuff) - 1, _T("%s - -  [%s]  SESSION_CLOSE"), ForeignAddress, timestamp);
		_ftprintf(pFile, _T("%s\n"), szBuff);
		break;
	case AQUAMESSYS_SESSION_EVENT_TYPE_FD_READ:
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, sizeof(szBuff) - 1, _T("%s - -  [%s]  SESSION_READ"), ForeignAddress, timestamp);
		_ftprintf(pFile, _T("%s\n"), szBuff);
		break;
	case AQUAMESSYS_SESSION_EVENT_TYPE_HANDSHAKE_FINISH:
		memset(szBuff, '\0', sizeof(szBuff));
		_sntprintf(szBuff, _countof(szBuff) - 1, _T("%s - -  [%s]  SESSION_HANDSHAKE_FINISH"), ForeignAddress, timestamp);
		_ftprintf(pFile, _T("%s\n"), szBuff);
		break;
	}
	fclose(pFile);

	return 1;
}

DWORD FuncSendThread(LPVOID lpvoid)
{
	CAquaMessageSession* session = (CAquaMessageSession*)lpvoid;

	tagMessageDataUserMessage MessageDataUserMessage;
	MessageDataUserMessage.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_START+1;
	MessageDataUserMessage.m_header.m_size = (unsigned short)(sizeof(tagMessageDataUserMessage));
	::_tcsncpy_s(MessageDataUserMessage.m_uid_from, sizeof(MessageDataUserMessage.m_uid_from), uid, _tcscnlen(uid, sizeof(uid)));
	::_tcsncpy_s(MessageDataUserMessage.m_uid_to, sizeof(MessageDataUserMessage.m_uid_to), uid_to, _tcscnlen(uid_to, sizeof(uid_to)));
	::_tcsncpy_s(MessageDataUserMessage.m_message, sizeof(MessageDataUserMessage.m_message), tcp_message_data, _tcscnlen(tcp_message_data, sizeof(tcp_message_data)));

	while(!g_bAppEnd) {
		session->send_message(&MessageDataUserMessage, sizeof(tagMessageDataUserMessage));
		Sleep(333);
	}

	return 0L;
}
DWORD FuncUDPSendThread(LPVOID lpvoid)
{
	CAquaMessageSession* session = (CAquaMessageSession*)lpvoid;

	tagMessageDataUserMessage MessageDataUserMessage;
	MessageDataUserMessage.m_header.m_type = AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_START+1;
	MessageDataUserMessage.m_header.m_size = (unsigned short)(sizeof(tagMessageDataUserMessage));
	::_tcsncpy_s(MessageDataUserMessage.m_uid_from, sizeof(MessageDataUserMessage.m_uid_from), uid, _tcscnlen(uid, sizeof(uid)));
	::_tcsncpy_s(MessageDataUserMessage.m_uid_to, sizeof(MessageDataUserMessage.m_uid_to), uid_to, _tcscnlen(uid_to, sizeof(uid_to)));
	::_tcsncpy_s(MessageDataUserMessage.m_message, sizeof(MessageDataUserMessage.m_message), udp_message_data, _tcscnlen(udp_message_data, sizeof(udp_message_data)));

	while(!g_bAppEnd) {
		session->sendto_udp_message(&MessageDataUserMessage, sizeof(tagMessageDataUserMessage), CONNECT_HOSTNAME_UDP, CONNECT_SERVICE_UDP);
		Sleep(333);
	}

	return 0L;
}

/** AvP[VC
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst,
				    LPSTR lpszCmdLine, int nCmdShow)
{
	/* WinSock initialize */
	WSADATA wsaData;
	WORD version = MAKEWORD(2, 0);	// Version 2.0 w
	int iRet=WSAStartup(version, &wsaData);
	if(0 != iRet) {
		printf("WinSock error\n");
		return FALSE;
	}
	if (wsaData.wVersion != version){
		printf("WinSock version not available\n");
		WSACleanup();
		return FALSE;
	}

	MSG msg;

	HINSTANCE hAquaMessageSystemDll = NULL;

	CAquaMessageSystem* pAquaMessageSystem = new CAquaMessageSystem;

	pAquaMessageSystem->CreateSessions(10);
	pAquaMessageSystem->CreateUDPSessions(10);

	if(0 == pAquaMessageSystem->InitSocketEvent()) {
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}

	tagExtensionCallFunction user_message;

	user_message.m_call_func = recv_user_message;
	user_message.m_type = AQUAMESSYS_MESSAGE_TYPE_USER_EXTENSION_START+1;
	user_message.m_size = sizeof(tagMessageDataUserMessage);
	pAquaMessageSystem->add_ExtensionCallFunction(user_message);
	
	user_message.m_call_func = session_event;
	user_message.m_type = AQUAMESSYS_MESSAGE_TYPE_SESSION_EVENT;
	user_message.m_size = sizeof(tagMessageDataSesssionEvent);
	pAquaMessageSystem->add_ExtensionCallFunction(user_message);

	CAquaMessageSession* session = pAquaMessageSystem->connect(CONNECT_HOSTNAME_TCP, CONNECT_SERVICE_TCP);
	if(NULL == session) {
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}
	if(!session->is_session_used()) {
		delete session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}
//	CAquaMessageSession* udp_session = pAquaMessageSystem->open_udp(PF_INET4);
	CAquaMessageSession* udp_session = pAquaMessageSystem->open_udp(PF_INET6);
	if(NULL == udp_session) {
		delete session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}
	if(!udp_session->is_udp_session_used()) {
		delete session;
		delete udp_session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}



	// }l[WIuWFNg
	if(!InitApp(hInstance, nCmdShow)) {
		// IuWFNg̔j
		delete session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}


	HANDLE hSendThread = NULL;
	unsigned int SendThreadId = 0;
	hSendThread = (HANDLE)_beginthreadex(NULL, 0x10000, (THREADFUNC)FuncSendThread, (LPVOID)session, 0, &SendThreadId); 
	if(NULL == hSendThread) {
		delete session;
		delete udp_session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}

	HANDLE hUDPSendThread = NULL;
	unsigned int UDPSendThreadId = 0;
	hUDPSendThread = (HANDLE)_beginthreadex(NULL, 0x10000, (THREADFUNC)FuncUDPSendThread, (LPVOID)udp_session, 0, &UDPSendThreadId); 
	if(NULL == hUDPSendThread) {
		delete session;
		delete udp_session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}

	if(0 == pAquaMessageSystem->DispatchSocketEvent()) {
		delete session;
		delete udp_session;
		::FreeLibrary(hAquaMessageSystemDll);
		WSACleanup();
		return FALSE;
	}

	while (!g_bAppEnd) {
		// bZ[WĂ邩?
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE)) {
			// bZ[W̏
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		Sleep(1);
	}
	delete session;
	delete udp_session;
	::FreeLibrary(hAquaMessageSystemDll);
	WSACleanup();
	return 0;
}

/** AvP[VC֐
 */
BOOL InitApp(HINSTANCE hInstance, int nCmdShow)
{
	BOOL bRet = FALSE;


	WNDCLASS wc;

	ZeroMemory( &wc, sizeof(WNDCLASS) );
	wc.style	= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = NULL;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hCursor = LoadCursor ( hInstance, IDC_ARROW );
	wc.hbrBackground = (HBRUSH)GetStockObject ( BLACK_BRUSH );
	wc.lpszMenuName = NULL;
	wc.lpszClassName = APPWINDOW_CLASS;

	bRet = RegisterClass(&wc);
	if(!bRet) {
		return FALSE;
	}

	// CEBhE̐
	HWND hWnd = CreateWindow (APPWINDOW_CLASS,
		_T("socket monitor"),
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		APPWINDOW_WIDTH,
		APPWINDOW_HEIGHT,
		NULL,
		NULL,
		hInstance,
		NULL );
	if (NULL == hWnd ) { 
		return FALSE;
	}
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;

}

/** CEBhẼR[obNvVW[
 */
LRESULT CALLBACK WndProc ( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	HINSTANCE hInstance = (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE);

	int iRet = 0;

	switch ( msg ) {
    case WM_KEYDOWN://L[{[h
		switch(wParam){
			case VK_ESCAPE:
				// EBhE̍ŏ
				::CloseWindow(hWnd);
				return 1;
		}
		return 0;
	case WM_DESTROY:
		PostQuitMessage ( 0 );
		return 0;
	case WM_ACTIVATE:
		return 0;
	case WM_PAINT:
		return 0;
	case WM_CLOSE:
		// ItO
		g_bAppEnd = TRUE;
		return 0;
	}
	return ( DefWindowProc ( hWnd, msg, wParam, lParam ) );
}
